﻿
; Tracer Directives         => ;$DisableDebugOutput() or ;$DisDBG - and ;$EnableDebugOutput() or ;$EnDBG
;                           => $LPP from Little PreProcessor (these lines are Skipped)

EnableExplicit

Global LPPF.b          = 0
Global sTabLen.s       = "   "
Global gMainInpFN.s                             ; global Main Input File
Global sgSkipF.s       = ""                     ; global skip string
Global gSkipF.b        = -1                     ; global skip flag

Global SkipUnusedProcsF.b                       ; used in TraceAuxFunct.pbi, must be before IncludeFile

IncludeFile "TracerAuxFunct.pbi"

Structure ProcDef
  Name.s              ; Procedure Name (es. Procedure GETFILENAME(...))
  Decl.s              ; Procedure Declaration Type (es. PROCEDUREDLL or PROCEDUREC.....)
  Used.b              ; Set if used somewhere (not only declared)
  
EndStructure

Global NewList lstProcedures.ProcDef()
Global NewList lstPBFiles.s()

Global sProcsUsed.s, sProcsDeclared.s, IsProcUsed.b

#All0orUsed1=0

Declare TraceFile(InpFN.s, OutFN.s, TracingF.b)
Declare GetUsedProceduresList(InpFN.s, TracingF, AllProcs.b=#All0orUsed1)

Define InpFN.s, OutFN.s
Define MaxKW, st.s
Define Progr, pbPID, hWnd, ret


; 0 = add line nr only, 1 = add procedure name, 2 = add procedure address,
; 4 = add line nr address

#ADDFLAG_LINENR     = 0             ; bitflag
#ADDFLAG_PROCNAME   = 1
#ADDFLAG_PROCADDR   = 2
#ADDFLAG_LINEADDR   = 4
#ADDFLAG_THREADID   = 8
#ADDFLAG_THREAD     = 16

; error codes
#FILE_ALREADY_TRACED = #WM_USER + 100

#CRLF2$ = #CRLF$ + #CRLF$

Define CmdLn.s


Define ini, fin
Global sDebug.s
Global sFilter.s
Global Target.s
Global TargetId
Global ProcessWnd.s
Global CtrlNameId.s
Global AddFlag.b

Global AddCodeF.b
Global LineNrLen
Global ProcNameLen
Global ProcAddrLen
Global HexAddrF.b
Global StartWithEmptyLineF.b
Global SepProcCallsF.b
Global ShowVarsF.b

Global ClearDebugViewLogF.b
Global RunPBF.b
Global OnlyIfNewerF.b
Global FixedTraceLen
Global SilentF.b
Global TestCompileF.b
Global ScanInlcudedFiles
Global AddRunInfoF.b
Global SameDestFolderF.b
Global ShowRunParamsF.b
Global SkipConstants.b
Global ProgParam0.s
Global LoadFilesInPBEF.b
Global CountProcCallsF.b
Global HeaderWrittenF.b
Global FileNr, BytesRead, TotalBytes

ProgParam0 = ProgramParameter(0)

CompilerIf #PB_Compiler_Debugger                            ; for Debug
  CmdLn = LCase(PeekS(GetCommandLine_()))
  CmdLn = Chr(34)+"C:\Program Files\PureBasic_430\Arch\anmXNpp\MathPad\MathPad.pb"+Chr(34)+" "+Chr(34) + "C:\Program Files\PureBasic_430\Arch\anmXNpp\MathPad\"+Chr(34)
  CmdLn = Chr(34)+"C:\Program Files\PureBasic_430\Arch\Tracer\Test\Test_EnTimer.pb"+Chr(34)+" "+Chr(34) + "C:\Program Files\PureBasic_430\Arch\Tracer\Test\"+Chr(34)
  
  ; cmdln = cmdln + " /tg DebugView /def /rn0 /su0 /if1 /lf1 /sp1"
  
  ; cmdln = cmdln + "/tg ProcessWnd /pw Notepad++ /cn Edit /def /rn0 /su0 /if1 /lf1 /sp1"
  cmdln = cmdln + "/tg ProcessWnd /pw Notepad /def /rn0 /su1 /if1 /lf2 /sp1 /sc1"
  ProgParam0 = StringField(CmdLn, 2, Chr(34))
CompilerEndIf

If CountProgramParameters() = 0 Or ProgParam0 = "/?" Or LCase(ProgParam0) = "/h" Or LCase(ProgParam0) = "/hd"
    OpenConsole()
    
    PrintN("Program: "+GetFilePart(#PB_Compiler_File)+" - ver. 0.0.3.0 (Build:"+Str(#pb_editor_buildcount)+")")
    PrintN("By: Carlo Somigliana - somic@libero.it, www.semelinanno.com")
    PrintN("Written in PureBasic - ver. "+StrD(#PB_Compiler_Version/100, 2)+" (x86)")
    PrintN("")
    PrintN("A program to automatically add debug output code to PB souces.")
    PrintN("Written to trace programs that can not be debugged in the PB IDE (es. dlls)")
    PrintN("")
    PrintN("Try it with a Debug Viewer program (es. DebugView by Sysinternals@)")
    ; PrintN(" Copyright@ 1998 - 2008 by Mark Russinovich - www.sysinternals.com)"); (Pls note that Microsoft@ acquired Sysinternals in July, 2006 but utils are still available)"
    PrintN("")
    PrintN("Code and binary are FREEWARE. Use and modify at YOUR OWN WISH and RISK.")
    PrintN("-------------------------------------------------------------------------------")
    
    ShowHelp(ProgramParameter(0))
    
    Input()
    
    CloseConsole()
    End
Else

    InpFN = ProgParam0
    OutFN = GetCmdLineParam(CmdLn, "/of")
      
    If FindString(CmdLn, "/def", 1) <> 0 Or FindString(CmdLn, "/d", 1) <> 0:     ; default config
        Target               = "DebugView" ; ProcessWnd
        ProcessWnd           = "Notepad,," ; or "Notepad.exe"
        CtrlNameId           = ""     ; Edit
        AddFlag              = #ADDFLAG_LINENR + #ADDFLAG_PROCNAME ;+ #ADDFLAG_PROCADDR; | #ADDFLAG_PROCADDR
        AddCodeF             = 1     ; add line code in the output string
        LineNrLen            = 5     ; space in characters of the line number field
        ProcNameLen          = 20    ; space in characters of the procedure name field
        ProcAddrLen          = 8     ; space in characters of the procedure address field
        FixedTraceLen        = 125   ; total length in characters of the debug line
        HexAddrF             = 0     ; write numbers in hex format
        StartWithEmptyLineF  = 1     ; send an empty line at the the beginning of the debug session
        SepProcCallsF        = 1     ; add an empty line at the entry of every procedure (for readeability)
        ShowVarsF            = 1     ; enable the Variable view feature
        ClearDebugViewLogF   = 1     ; try to clear
        RunPBF               = 0     ; run the purebasic editor after Tracing
        OnlyIfNewerF         = 0     ; tells the program execute only if source file is newer than dest file
        SilentF              = 1     ; run without prompting messages
        TestCompileF         = 0     ; test the generated code trying to compile it
        ScanInlcudedFiles    = 0     ; trace also file in the IncludeFile keyword; modify instruction
        AddRunInfoF          = 1     ; add a RunInfo comment in the first line
        SameDestFolderF      = 1     ; write output files in the same folder (and adapt IncludeFile names)
        ShowRunParamsF       = 0     ; show run parameters (for debugging)
        SkipUnUsedProcsF     = 0     ; Skip Unused Procedures
        SkipConstants        = 0     ; Skip Constants
        LoadFilesInPBEF      = 1     ; LoadFilesInPBE (0, 1 or 2)
        CountProcCallsF      = 0     ; Count Procedure Calls TO BE IMPLEMENTED
    EndIf

    sFilter = GetCmdLineParam(CmdLn, "/fl")                                                  ; add Default value only when <> 0
    Target     = GetCmdLineParam(CmdLn, "/tg", Target)
    ProcessWnd = GetCmdLineParam(CmdLn, "/pw", ProcessWnd)
    CtrlNameId = GetCmdLineParam(CmdLn, "/cn", CtrlNameId)
    AddFlag = Val(GetCmdLineParam(CmdLn, "/af", Str(AddFlag)))
    AddCodeF = Val(GetCmdLineParam(CmdLn, "/ac", Str(AddCodeF)))
    LineNrLen = Val(GetCmdLineParam(CmdLn, "/ln", Str(LineNrLen)))
    ProcNameLen = Val(GetCmdLineParam(CmdLn, "/pn", Str(ProcNameLen)))
    ProcAddrLen  = Val(GetCmdLineParam(CmdLn, "/pa", Str(ProcAddrLen)))
    FixedTraceLen = Val(GetCmdLineParam(CmdLn, "/xc", Str(FixedTraceLen)))
    
    HexAddrF            = Val(GetCmdLineParam(CmdLn, "/he", Str(HexAddrF)))
    StartWithEmptyLineF = Val(GetCmdLineParam(CmdLn, "/el", Str(StartWithEmptyLineF)))
    SepProcCallsF       = Val(GetCmdLineParam(CmdLn, "/sp", Str(SepProcCallsF)))
    ClearDebugViewLogF  = Val(GetCmdLineParam(CmdLn, "/cd", Str(ClearDebugViewLogF)))
    RunPBF              = Val(GetCmdLineParam(CmdLn, "/rn"))
    TestCompileF        = Val(GetCmdLineParam(CmdLn, "/tc"))
    OnlyIfNewerF        = Val(GetCmdLineParam(CmdLn, "/on"))
    SilentF             = Val(GetCmdLineParam(CmdLn, "/sl", Str(SilentF)))
    ScanInlcudedFiles   = Val(GetCmdLineParam(CmdLn, "/if"))
    AddRunInfoF         = Val(GetCmdLineParam(CmdLn, "/ri", Str(AddRunInfoF)))
    SameDestFolderF     = Val(GetCmdLineParam(CmdLn, "/sd", Str(SameDestFolderF)))
    
    ShowVarsF           = Val(GetCmdLineParam(CmdLn, "/sv", Str(ShowVarsF)))
    ShowRunParamsF      = Val(GetCmdLineParam(CmdLn, "/rp"))
    SkipUnusedProcsF    = Val(GetCmdLineParam(CmdLn, "/su", Str(SkipUnusedProcsF)))
    SkipConstants       = Val(GetCmdLineParam(CmdLn, "/sc", Str(SkipConstants)))
    LoadFilesInPBEF     = Val(GetCmdLineParam(CmdLn, "/lf", Str(LoadFilesInPBEF)))
    CountProcCallsF     = Val(GetCmdLineParam(CmdLn, "/cc", Str(CountProcCallsF)))
EndIf

CompilerIf #PB_Compiler_Debugger
    If InpFN = ""
        InpFN = "C:\Program Files\PureBasic_430\Arch\Tracer\Test\Test_EnTimer.pb"   ; for debugging
    EndIf
CompilerEndIf

gMainInpFN = InpFN

If OutFN = ""
    OutFN = GetPathPart(InpFN)+"_$_"+GetFilePart(InpFN)
  
ElseIf PathIsDirectory_(OutFN)
    PathAddBackslash_(OutFN)
    OutFN = OutFN+"_$_"+GetFilePart(InpFN)
    
EndIf

If OnlyIfNewerF
    Define InpFtime, OutFTime
    InpFTime = GetFileDate(InpFN, #PB_Date_Modified)
    OutFTime = GetFileDate(OutFN, #PB_Date_Modified)
    If InpFTime <= OutFTime
        If Not SilentF : MessageRequester("Tracer", "Input File older than Output. Nothing done."): EndIf
        End 0
    
    EndIf
  
EndIf


; /////////////////////////////////////////////////////////////////////////////////////
; /// look for nr of space characters for each Tab to improve allignement of strings
Define PBprefs.s = ""   ; sTabLen is defaulted 4 spaces "    "; if not found it is not a critical error

If FindString(LCase(PeekS(GetCommandLine_())), "/local", 1)     ; test for /local directive
    PBprefs = GetPathPart(gMainInpFN)+"Purebasic.prefs"
  
EndIf

If Not FileSize(pbPrefs)
    PBprefs = #PB_Compiler_Home+"Purebasic.prefs"
  
EndIf

If Not FileSize(pbPrefs)
    PBPrefs = GetEnvironmentVariable("APPDATA")+"\Purebasic\Purebasic.prefs"
  
EndIf
st = Space(100)
k = GetPrivateProfileString_("Global", "TabLength", "4", st, 100, pbPrefs)
sTabLen = Space(Val(st))
; if not found it is not a critical error
; //////////////////////////////////////////////////////////////////////////////////////////////
#Target_LDEBUG  = 1
#Target_DBGSTR  = 2
#Target_PRCWND  = 3
#Target_PBEDT   = 4
#Target_MMF     = 5

Select LCase(Target)
Case "stdfile"                  ; save Debug Output to std file (c:\pbfilename.dbg)
    sDebug = "lDebugF"          ; THIS OPTION SENSIBLY SLOWS DOWN THE EXECUTION
    TargetId = #Target_LDEBUG
    ; write To file; the DebugF() function must be defined (copied) in the target code
    ; if it is not found it will be added the line InculdeFile "lDebugF()"
    ; this file must be in the program directory
    ;     Case "CustFile"                 ; save Debug Output to custom file
    ;         sDebug = "DebugF"
Case "debugview"               ; use API OutputDebugString_ (a pipe for debug - IT IS VERY FAST)
    sDebug = "OutDS_"
    TargetId = #Target_DBGSTR
    
Case "processwnd"               ;
    sDebug = "SendToWnd"
    TargetId = #Target_PRCWND
  
; Case "pbeditor"               ;
;     sDebug = "SendToPBEditor"
;     TargetId = #Target_PBEDT
  
Case "memmapfile"               ; TO BE IMPLEMENTED
    sDebug = "WriteMemMapFile"
    TargetId = #Target_MMF
  
Case "clipboard"               ;
    sDebug = "SendToClpB"
    TargetId = #Target_MMF
  
Default
    sDebug = "OutDS_"
    TargetId = #Target_DBGSTR
  
EndSelect


; sFilter = "pbPrjMgr.pb"         ; this is the name of the output file, used as filter by the DebugView App (SysInternals)
If sFilter = ""
    sFilter = GetFilePart(gMainInpFN)
EndIf



Procedure VerifyInpFN(lInpFN.s)
    Protected ExitCode, InpFId
    
    If Left(GetFilePart(lInpFN.s), 3) = "_$_"
        ExitCode = #FILE_ALREADY_TRACED
        If Not SilentF
            MessageRequester("Tracer", "Input File already Traced."+#CRLF$+lInpFn)
        EndIf
        ProcedureReturn ExitCode
    
    EndIf
    
    InpFId = ReadFile(#PB_Any, lInpFN)
    If Not InpFId
        ExitCode = GetLastError_()
        If Not SilentF
            MessageRequester("Tracer", "Error opening file."+#CRLF$+lInpFn+ #CRLF2$ + "API Error code: "+Str(ExitCode))
        EndIf
        ProcedureReturn ExitCode
        ; End ExitCode
    EndIf
    
    ProcedureReturn -InpFId
  
EndProcedure


Procedure.s TestForIncludeInstr(sLine.s, *CurPath, TracingF.b, AllProcsF.b, *IsACommentLineF.b)
Protected pos, sXIncl.s, sInclFN.s, sInclPath.s, CurPath.s, sInclOutFN.s , sSameDestPath.s, cnt

    
    pos = FindString(UCase(sLine), "$LPP", 1)
    If pos
        PokeB(*IsACommentLineF, 0)
        ProcedureReturn sLine
    EndIf
    
    pos = FindString(sLine, ";", 1)
    If pos
        cnt = CountString(Mid(sLine, 1, pos), Chr(34))          ; if quotes are odd then ; is inside a string
        If (cnt % 2) = 1
            pos = 0
        Else
            sLine = Left(sLine, pos-1)                          ; strip comments
            If Trim(sLine) = ""                                 ; comment line
                PokeB(*IsACommentLineF, 1)
                ProcedureReturn sLine
                
            EndIf    
        EndIf   
    EndIf 
    
    CurPath =PeekS(*CurPath)
    sSameDestPath = CurPath
    
    sXIncl = ""
    sInclFN = StringFieldKey(sLine, LCase("XIncludeFile"), "", "/")
    
    
    If sInclFN = ""
        sInclFN = StringFieldKey(sLine, LCase("IncludeFile"), "", "/")
        ;             Else
        ;                 CallDebugger
    Else
        sXIncl = "X"
    EndIf
    sInclPath = StringFieldKey(sLine, LCase("IncludePath"), "", "/")
    
    If sInclFN <> "" Or sInclPath <> ""
        sInclFN = Mid(sInclFN, 2, Len(sInclFN)-2)           ; removes the two quotes at begin and end of string
        sInclPath = Mid(sInclPath, 2, Len(sInclPath)-2)     ; removes the two quotes at begin and end of string
        
    
    If sInclFN <> "" And sInclPath = ""
        If PathIsRelative_(sInclFN)
            sInclFN = CurPath + sInclFN
        Else
        ; no changes
        EndIf
      
        If SameDestFolderF
            sInclOutFN = sSameDestPath
        Else
            sInclOutFN = GetPathPart(sInclFN)
        EndIf
        If ScanInlcudedFiles
            sInclOutFN = sInclOutFN+"_$_"+GetFilePart(sInclFN)
            If FileSize(sInclOutFN)
                DeleteFile(sInclOutFN)
            EndIf   
        Else
            sInclOutFN = sInclOutFN+GetFilePart(sInclFN)
        EndIf 
        sLine = sXIncl + "IncludeFile " +Chr(34)+ sInclOutFN  + Chr(34)         ; set  file to include (itself)
        
      
        AddElement(lstPBFiles())
        lstPBFiles() = sInclOutFN
        
        If TracingF And ScanInlcudedFiles
            
            TraceFile(sInclFN, sInclOutFN, TracingF)                            ; recursively call TraceFile
        Else
            ; Debug sInclOutFN
            GetUsedProceduresList(sInclFN, TracingF, AllProcsF)
        EndIf
      
    ElseIf sInclFN = "" And sInclPath <> ""
        CurPath = sInclPath
        sLine = "IncludePath " +Chr(34)+ sInclPath  + Chr(34)                   ; set  path to include (itself)
      
    EndIf
    
    EndIf
    
    PokeB(*IsACommentLineF, 0)
    PokeS(*CurPath, CurPath)
    ProcedureReturn sLine
  
EndProcedure

#PROC_NONE = 0
#PROC_DECL = 1
#PROC_CALL = 2

Procedure LookForAProcedureName(sLine.s)
  Protected sProcName.s
  
  ForEach lstProcedures()
    With lstProcedures()
      
      
      sProcName = \Name
      ; Debug "lstProcNames(): "+\name
      
      ;If sLine = "     If (EtimeFrequency(*mtime))": CallDebugger: EndIf
      
      sProcName = GetKeyWord(sLine, \Name, -1, 1)                         ; uses LCase for both strings
      ; Debug sLine
      
      If sProcName <> "" And  Not FindString(sProcsUsed, LCase(\Name), 1) ; to avoid duplicates
        
        
        If FindString(LCase(sLine), LCase(\Decl), 1)                            ; it is a Procedure declaration
          
          ProcedureReturn #PROC_DECL
          ; CallDebugger
        Else                                                                    ; it is a procedure call
          \Used = 1
          ; IsProcUsed = 1
          sProcsUsed = sProcsUsed + LCase(\Name) + " "
          ProcedureReturn #PROC_CALL
          
        EndIf
      EndIf
      
    EndWith
  Next
  
EndProcedure

Procedure GetUsedProceduresList(InpFN.s, TracingF, AllProcsF.b=1)
  Protected InpFId, ExitCode, sf, sLine.s
  Protected CurPath.s, sInpLine.s, LineNr, sXIncl.s, sInclFN.s, sInclPath.s, sInclOutFN.s; ; , sInclFN.s, , , LineNr
  Protected ProcName.s, sProcName.s, sSameDestPath.s, IsACommentLineF.b
  Protected st.s, pos, ret
  
  ExitCode = VerifyInpFN(InpFN)
  If ExitCode > 0
    ProcedureReturn ExitCode
  Else
    InpFId = -ExitCode
  EndIf
  
  TotalBytes = TotalBytes + Lof(InpFId)

  If InpFId
    
    sf = ReadStringFormat(InpFId)
    
    CurPath = GetPathPart(InpFN)
    If CurPath = ""
      CurPath = GetPathPart(PeekS(GetCommandLine_()))             ; GetCurrentDirectory()
    EndIf
    sSameDestPath = CurPath                                         ; save all files in the same Path
    ; Debug "   CurPath= "+CurPath
    
    While Not Eof(InpFId)
      
      sLine = ReadString(InpFId, sf)
      sInpLine = sLine
      ; If FindString(sLine, "Recompile", 1): CallDebugger: EndIf
      
      ; Debug RSet(Str(linenr), 4) + " - " + sLine
      
      LineNr = LineNr + 1                                         ; counter out of second while wend loop
      
      ; test to see if it is an IncludeFile or IncludePath instruction
      sLine = TestForIncludeInstr(sLine, @CurPath, TracingF, AllProcsF, @IsACommentLineF)
      
      ; /////////////////////////////////////////////////////////////////////////////////////////////////////
      ; /// SKIP EMPTY LINES
      
      If Trim(sLine) = ""
        Goto NextLine
      EndIf
      
      ; Debug Str(LinenR)+" ******** CurrProcName :"+CurrProcName
      
      
      ; /////////////////////////////////////////////////////////////////////////////////////////////////////
      ; /// Get ActionCode associate with the line/instruction/keyword
      
      If AllProcsF                                                    ; create a list of All defined procedures
        
        ProcName = Space(1000)
        pos = IsAProcDeclaration(sLine, @ProcName)
        
        If pos                                                      ; it is a procedure declaration
          AddElement(lstProcedures())
          
          With lstProcedures()
            \Name = Trim(ProcName)                              ; store procedure name
            \Decl = skw(pos)                                    ; store declaration keyword (es. ProcedureDLL, etc)
            sProcsDeclared = sProcsDeclared + LCase(ProcName) + " "
            
            If FindString("attachprocess detachprocess attachthread detachthread ", LCase(ProcName), 1)
              
              \Used = 1
              sProcsUsed = sProcsUsed + LCase(ProcName) + " "
              
            EndIf
          EndWith
          
        EndIf
        
      Else                                                                        ; get Used Procedures
        
        ; If FindString(sline, "EtimeFrequency",1 ): CallDebugger: EndIf
        
        ret = LookForAProcedureName(sLine)                                      ; look for an existing procedure name
        ; in the source code line
        
        
        
        If ret = #PROC_DECL                                                     ; it is a Procedure declaration
          ; CallDebugger
          ; ??? if inside a Usedd Procedure block or already marked a used
          IsProcUsed = FindString(LCase(sProcsUsed), LCase(lstProcedures()\Name), 1)
          If IsProcUsed ; Or FindString(LCase(sProcsUsed), LCase(lstProcedures()\Name), 1)
            lstProcedures()\Used = 1
            ; \Used can only become set 0 to 1, it can't go back to 0
          EndIf
          
        ElseIf RET = #PROC_CALL                                                 ; it is a procedure call
          
          If Not FindString(LCase(sProcsUsed), LCase(lstProcedures()\Name), 1)
            sProcsUsed = sProcsUsed + LCase(lstProcedures()\Name) + " "
            IsProcUsed = 1
            lstProcedures()\Used = 1
          EndIf
        Else
          ; DO NOTHING
        EndIf
        
        ; Debug "--------------"
      EndIf
      NextLine:
    Wend
    
  EndIf
  
  
EndProcedure


Procedure TraceFile(InpFN.s, OutFN.s, TracingF.b)
Protected InpFId, ExitCode, sf, OutFId, sLine.s, sInpLine.s, pos, LineNr, SkippedLines, sAuxLine.s, sRunTime.s
Protected LastActFlag, SingleLineActFlag, SkipCurrLineF, BlockSkipF, ret, IsACommentLineF.b, DirectF
Protected CurPath.s, EndProcF.b, sThread.s, CurrThr, NewProcNameF;, sInclFN.s, sInclOutFN.s, sInclPath.s, sXIncl.s
Protected sLineNr.s, ProcName.s, CurrProcName.s, sProcName.s, ProcAddr.s, sProcAddr.s, sLineAddr.s, sCode.s
Protected st.s, sStartLine.s, sTrace.s, sTimer.s, EndOfCodeF, sProcedures.s, sSameDestPath.s, Cond_SKIP_THIS_LINE
Protected TFile.s
      
    ExitCode = VerifyInpFN(InpFN)
    If ExitCode > 0
        ProcedureReturn ExitCode
    Else
        InpFId = -ExitCode
    EndIf
    
    ; TotalBytes = Lof(InpFid)
    TFile = GetFilePart(InpFN)
    
    If Not InpFId: ProcedureReturn 0: EndIf 

    FileNr = FileNr + 1
    SetGadgetText(3, "Processing file: " +Inpfn)
    SetGadgetState (0, FileNr)
    
    sf = ReadStringFormat(InpFId)
    OutFId = CreateFile(#PB_Any, OutFN)
    WriteStringFormat(OutFId, sf)
    
    CurPath = GetPathPart(InpFN)
    If CurPath = ""
        CurPath = GetPathPart(PeekS(GetCommandLine_())) ; GetCurrentDirectory()
    EndIf
    sSameDestPath = CurPath                                    ; save all files in the same Path
    ; Debug "   CurPath= "+CurPath
    
    While Not Eof(InpFId)
      
LoopWhileIni:
        sLine = ReadString(InpFId, sf)
        
        BytesRead = BytesRead + StringByteLength(sLine)+2 ; Loc(InpFId)
        ret = 100*BytesRead /TotalBytes

        SetGadgetState (1, ret)   ;  set 2nd progressbar (ID = 1) to 50 of 200
;        SetGadgetText(4, Str(ret))

        sInpLine = sLine
        ; Debug RSet(Str(linenr), 4) + " - " + sLine
        
        LineNr = LineNr + 1                                     ; counter out of second while wend loop
        ; If LineNr = 236: CallDebugger: EndIf
        ; test to see if it is an IncludeFile or IncludePath instruction
        
        DirectF = IsADirective(sLine)
        
        If Not DirectF
        
            If Linenr = 78
            ;      CallDebugger
            EndIf
            sLine = TestForIncludeInstr(sLine, @CurPath, 1, 0, @IsACommentLineF)
            
            
            ; /////////////////////////////////////////////////////////////////////////////////////////////////////
            ; /// SKIP EMPTY LINES
            
            If Trim(sLine) = "" Or Trim(sLine) = #TAB$  
                If Not HeaderWrittenF And LineNr =< 5 ;And ret <> 0
                    Goto Write1stLine
                    
                Else
                    If IsACommentLineF And SingleLineActFlag <> #START_PB_SETTINGS
                        If LineNr > 5                  ; restore comment line to show it
                            sLine = AddSpaces(" ; /// comment line: ", FixedTraceLen)+sInpLine
                        EndIf
                    EndIf
                    
                    Goto WritesLine
                EndIf
            EndIf
        
        EndIf
        
        ; /////////////////////////////////////////////////////////////////////////////////////////////////////
        ; /// Get ActionCode associate with the line/instruction/keyword
        
        pos = CheckSkipKeyWord(sLine)
        
        
        ; gSkipF is a flag used to enable (and disable) globally the tracing instructions (defined in TracerAux.pbi)
        ; it is used when a traced procedure is called inside a skip block; the call to the tracing
        ; instructions will exit immediately, without sending any debug string
        
        sgSkipF = ""
        gSkipF = -1
        If TargetId = #Target_PRCWND
            If LineActionFlag(pos) = #START_LOOP_SKIPPING_FROM_THIS_LINE Or LineActionFlag(pos) = #START_BLOCK_SKIPPING_FROM_THIS_LINE
                sgSkipF = " globalSkipF = 1 : "              ; this instruction is copied in the dest file to be executed and disable tracing
                gSkipF = 1
                
            ElseIf  LineActionFlag(pos) = #STOP_LOOP_SKIPPING_FROM_NEXT_LINE Or LineActionFlag(pos) = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE
                sgSkipF = " : globalSkipF = 0"               ; this instruction is copied in the dest file to be executed and enable tracing
                gSkipF = 0
            Else
            EndIf
        EndIf
      
        ;+ --- Tracer.pb v0030 ---------------------------------------------------------------
        
        Cond_SKIP_THIS_LINE  = ((LastActFlag = #START_SKIP_ALL_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE))
        Cond_SKIP_THIS_LINE  = Cond_SKIP_THIS_LINE And ((LastActFlag <> #TRACE_LOOPS_DIRECTIVE) And (LineActionFlag(pos) <> #STOP_SKIP_ALL_DIRECTIVE) )
        ;                 If LineActionFlag(pos) = #START_SKIP_ALL_DIRECTIVE Or linenr = 28
        ;                     CallDebugger
        ;                 EndIf
      
        ; manages the MultipleLines character (es. ' _' for the $LPP = LittlePreProcessor)
        ; lines are skipped entirely
        If (LastActFlag = #SKIP_2_LINES) And (LineActionFlag(pos) = #DONT_SKIP_THIS_LINE)
            LastActFlag = #SKIP_THIS_LINE
            SingleLineActFlag = #SKIP_THIS_LINE
        
        ElseIf Cond_SKIP_THIS_LINE
            ; LastActFlag = #START_SKIPPING_DIRECTIVE
            SingleLineActFlag = #SKIP_THIS_LINE
        
        ElseIf LastActFlag = #START_PB_SETTINGS
        ; nothing done
        ; CallDebugger
        
        Else
            LastActFlag = LineActionFlag(pos)
            SingleLineActFlag = LineActionFlag(pos)
        
        EndIf
        
        If EndProcF                   ; this comes from the previous loop
            ProcName = ""
            CurrProcName = ""    
        EndIf
                                    ; look for the procedure name
        ProcName = GetKeyWord(sLine, "procedureCDLL", ProcIdx, #RET_LINEWORD)
        If ProcName <> "": Goto line1: EndIf  
        ProcName = GetKeyWord(sLine, "ProcedureDLL", ProcIdx, #RET_LINEWORD)
        If ProcName <> "": Goto line1: EndIf  
        ProcName = GetKeyWord(sLine, "ProcedureC", ProcIdx, #RET_LINEWORD)
        If ProcName <> "": Goto line1: EndIf  
        ProcName = GetKeyWord(sLine, "Procedure", ProcIdx, #RET_LINEWORD)
      
Line1:
        If ProcName <> ""
            NewProcNameF = 1
        Else
            NewProcNameF = 0
        EndIf 
        
        EndProcF = 0                  
        EndProcF = (GetKeyWord(sLine, "endprocedure", EndProcIdx, #RET_KEYWORD) = "endprocedure")
      
        If NewProcNameF
            CurrProcName = ProcName
            ret = SkipUnUsedProcs(sLine, ProcName, sProcsUsed, BlockSkipF)
            If RET
                BlockSkipF = ret
                ; CallDebugger
            EndIf   
        EndIf
        
        SkipCurrLineF = SingleLineActFlag | BlockSkipF
        
            
        If (SingleLineActFlag = #START_BLOCK_SKIPPING_FROM_THIS_LINE) Or (SingleLineActFlag = #START_LOOP_SKIPPING_FROM_THIS_LINE)
            BlockSkipF = 1
          
        ElseIf (SingleLineActFlag = #START_BLOCK_SKIPPING_FROM_NEXT_LINE) ; Or (SingleLineActFlag = #START_LOOP_SKIPPING_FROM_THIS_LINE)
            ; this is BEFORE getting the next ActionFlag (es. Select )
            SkipCurrLineF = #DONT_SKIP_THIS_LINE
            LastActFlag = #START_BLOCK_SKIPPING_FROM_NEXT_LINE
        
        ElseIf (SingleLineActFlag = #STOP_BLOCK_SKIPPING_FROM_THIS_LINE)
            SkipCurrLineF = #DONT_SKIP_THIS_LINE
            BlockSkipF = 0
          
        ElseIf (SingleLineActFlag = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE)
            SkipCurrLineF = 1
            BlockSkipF = 0
          
        ElseIf (SingleLineActFlag = #TRACE_THIS_LINE)                       ; override everything
            SkipCurrLineF = 0
          
        EndIf
        ; If BlockSkipF : CallDebugger: EndIf
        ; Debug "BlockSkipF = "+Str(BlockSkipF)
        ;- --- End Of Tracer v0030 ------------------------------------------------------------------------------    
        
        ;+
        ; ///////////////////////////////////////////////////////////////////////////////////////////////////////
        ; /// 1. look for the keyword Procedure to get the name
        ; /// 2. build the debug output string (first assmeble the SUBstrings that will build the final line)
        
        ; *** LINE NR
        
        sLineNr = RSet(Str(LineNr), LineNrLen, " ")+" "+Chr(34)                                  ; string for line numbers
        
        ; *** PROCEDURE NAME
        
        If AddFlag & #ADDFLAG_PROCNAME                          ; add procedure name (= #PB_Compiler_Procedure)
            If CurrProcName <> ""
                sProcName = "'+LSet('"+CurrProcName+"', "+Str(ProcNameLen)+")+',"                       ; purebasic instruction
            Else
                sProcName = "'+LSet(#PB_Compiler_Procedure, "+Str(ProcNameLen)+")+',"                   ; purebasic instruction
            EndIf
        ;       EndIf
            sProcName = ReplC(sProcName)
          ; SetClipboardText(sProcName)
        Else
            sProcName = ""
        EndIf
        
        
        ; *** PROCEDURE ADDRESS
        
        If (AddFlag & #ADDFLAG_PROCADDR) And (ProcName <> "")   ; add procedure address (= [Hex]@ProcedureName())
          
            ProcAddr = "@"+ProcName+"()"
            If HexAddrF                                         ; Hexadecimal memory addresses
                ; sThread = " [$'+Hex(sTID())+']"                         ; short code
                sProcAddr =   ", [$'+Hex("+ProcAddr+"']"
            Else
                ; sThread = " ['+LSet(sTID(), "+Str(LineNrLen)+")+']"     ; short code
                sProcAddr   = ", ['+RSet(Str("+ProcAddr+"), "+Str(ProcAddrLen)+")+')"
            EndIf
            sProcAddr = ReplC(sProcAddr)
          
        Else
            sProcAddr = ""
        EndIf
        
        
        ; *** LINE ADDRESS
        
        If AddFlag & #ADDFLAG_LINEADDR                          ; add line nr address (ASM) - to be implemented
            sLineAddr = ", ASM"
        Else
            sLineAddr = ""
        EndIf
        
        
        ; THREADID NUMBER
        If AddFlag & #ADDFLAG_THREADID                          ; add ThreadID
            ; CurrThr = GetCurrentThread_()
            If HexAddrF                                         ; Hexadecimal value
                ; sThread =     "+'($'+Hex('+GetCurrentThread_()+'))'"
                sThread = " [$'+Hex(sTID())+']"                         ; short code
            Else
                ; sThread = " ['+LSet(Str(GetCurrentThreadId_()), "+Str(LineNrLen)+")+']" 
                sThread = " ['+LSet(sTID(), "+Str(LineNrLen)+")+']"     ; short code
                
            EndIf
            sThread = ReplC(sThread)
            
        ElseIf AddFlag & #ADDFLAG_THREAD                        ; gives -2 ???
            If HexAddrF                                         ; Hexadecimal value
                sThread = " [$'+Hex(sTh())+']"
            Else
                sThread = " ['+LSet(sTh(), "+Str(LineNrLen)+")+']"
                
            EndIf
            sThread = ReplC(sThread)
        
        Else
            sThread = ""
        EndIf
        
        ; *** ORIGINAL CODE
        
        If AddCodeF
          
            sCode = CutAnyComments(sInpLine, 0)
            sCode = "+"+ Chr(34)+ " |"+ ReplaceString(sCode, Chr(34), "'") +Chr(34)
          
        Else
            sCode = ""
        EndIf
        ;-    
        
        ; ////////////////////////////////////////////////////////////////////////////////////////////////////
        ; /// manage the assembly of the result string
        ;
        Write1stLine:
        
        If Not HeaderWrittenF And SkipCurrLineF <> #SKIP_LPP_DIRECTIVE                    ; write first line
          
            ; //////////////////////////////////////////////////////////
            ; modify the Main Source file adding an IncludeFile instrunction to the TracerAux.pbi file, containing support
            ; routines and variables, and that will be copied in the same folder
            ;
            sStartLine = ""
            ;                If (Add_TracerAuxF Or MissingHRTimerF)
            ; we don't care too much of having the same line numbers between source and
            ; destination because the destination is really messy and almost useless
            ; (needed only for compiling the dll)
            
            ; this must be the first line in the main source file
            ;
            sStartLine = "XIncludeFile "+Chr(34)+GetPathPart(gMainInpFN )+"_$_TracerAux.pbi "+Chr(34) + ": "
            ; WriteString(OutFId, ReplC(st))
            ;                     Add_TracerAuxF = 0                          ; lDebugF is now available (do not repeat this code)
            ;                     MissingHRTimerF = 0                         ; lDebugF is now available (do not repeat this code)
            ;                EndIf
            
            sRunTime = "; Run Time: "+FormatDate("%dd/%mm - %hh:%ii:%ss", Date())
            If AddRunInfoF                                  ; this timestamp is written in the main source
                sStartLine = sStartLine + sRunTime
                ; Run Time: "13/09 01:12:13- Il De bello gallico"
            EndIf
            
            WriteStringN(OutFId, ReplC(sStartLine))         ; write string at the fist position of main source file
            ; SetClipboardText(sTrace)
            
            ; this lines are written in the TracerAux file and executed at first because IncludeFile is put in the first line
            ; of the main source file
            ;
            sAuxLine = "EnableExplicit "+ sRunTime + #CRLF$
            sAuxLine = sAuxLine + "#ProcessWnd = "+Chr(34)+ProcessWnd+Chr(34)+": #CtrlNameId = "+Chr(34)+CtrlNameId+Chr(34)+";"+#CRLF$
            sAuxLine = sAuxLine + "Declare SendToWnd(String$, TxtEncode = 0)" + #CRLF$
            sAuxLine = sAuxLine + "Declare OutDS_(String$)" + #CRLF$
          
        
            If StartWithEmptyLineF                          ; add a START message as the first output string: adding this line of code at
                ; the beginning of the source code forces the program to execute it at first
                sAuxLine = sAuxLine + sDebug+"("+Chr(34)+TFile+": START "+Chr(34)+"): "
            
            EndIf
            
            ; this line is written in the TracerAux file and executed at first because IncludeFile is put as the first instruction
            ;
            sAuxLine = sAuxLine + sDebug+"('"+TFile+": "+LSet("Procedure", ProcNameLen)+","+LSet("ProcAddress", ProcAddrLen)
            sAuxLine = sAuxLine + ", "+LSet("Thread", LineNrLen)+","+LSet("Line #", LineNrLen)+"'):"  ; +, , LineAddr'): "
            
            ; now we create the _$_TracerAux.pbi file taking it from the Tracer binary 
            ;
            CreateFile(1, GetPathPart(InpFN)+"_$_TracerAux.pbi")
            WriteStringFormat(1, #PB_Ascii)
            
            WriteString(1, ReplC(sAuxLine), #PB_Ascii)
            
            ; skip the first 3+14 characters (FileFormat characters and the EnableSxplicit string)
            ; TracerAux.pbi file format is ASCII
            ;
            WriteData(1, ?lblPBSource+3+Len("EnableExplicit"), ?EndlblPBSource - ?lblPBSource)
            CloseFile(1)
            
            ; disable writting the header (written only the first time in the main file)
            HeaderWrittenF = 1                  
          
        
        ; ///////////////////////////////////////////////////////////////////////////////////////
        ; /// assemble the FINAL debug output string
        
        ElseIf Not SkipCurrLineF                              
          
            ; sTrace = sDebug+"("+Chr(34)+TFile+": " + sLineNr + sProcName + sProcAddr + sLineAddr + sCode +Chr(34) +")" ; +":"
            sTrace = sDebug+"("+Chr(34)+TFile+sThread+": " + sProcName + sProcAddr + sLineNr + sLineAddr + sCode  +")" ; +":"
            ; will AddSpaces later
          
        ElseIf SingleLineActFlag = #ADD_CMD_HRTIMER_START
            sTimer = "HRTimer(#HRT_START)"
            sTrace = sDebug+"("+Chr(34)+TFile+sThread+": " +sProcName + sLineNr+"+"+Chr(34)+" |"+sTimer+Chr(34)+"): "+sTimer
            sTrace = AddSpaces(sTrace, FixedTraceLen)
            sLine = sTrace + ": "+sLine
          
        ElseIf SingleLineActFlag = #ADD_CMD_HRTIMER_STOP
            sTimer = "HRTimer(#HRT_GET_ms)"
            
            sTrace = sDebug+"("+Chr(34)+TFile+sThread+": " +sProcName + sLineNr + "+"+Chr(34)+" | HRTimer:"+Chr(34)+"+Str(" +sTimer+"))"
            sTrace = AddSpaces(sTrace, FixedTraceLen)
            sLine = sTrace + ": " + sLine
          
        EndIf
        
        If IsACommentLineF And LineNr =< 5 And (HeaderWrittenF = 1) And SkipCurrLineF <> #SKIP_LPP_DIRECTIVE
            HeaderWrittenF = 2                          ; after written IncludeFIle "..." in the main source file, if a comment
            Goto LoopWhileIni                           ; line is found in the first 5 lines, then skip one line to realign
            
        EndIf                                         ; line numbers (between Input and _$_Output file)
        
        
        If Not SkipCurrLineF                                            ; add to the debug output string the original code (to be executed)
          
            If Trim(sInpLine) <> "" And Left(Trim(sInpLine), 1) <> ";"
                sTrace = AddSpaces(sTrace, FixedTraceLen)
                ; Debug DbgStrAfter(pos)
                
                If SepProcCallsF 
                    If NewProcNameF 
                        ;If DbgStrAfter(pos)
                        sLine = sLine + ": " + sDebug+"("+Chr(34)+TFile+": "+Chr(34)+")"
                        NewProcNameF = 0
                    EndIf     
                    If EndProcF 
                        ;if Not DbgStrAfter(pos)
                        sLine = sDebug+"("+Chr(34)+TFile+": "+Chr(34)+")" +": "+sLine
                    
                    EndIf   
                EndIf   
                If Not DbgStrAfter(pos)
                    sLine = sTrace + ": "+ sLine                        ; add Trace code
                Else
                    sLine = sLine + ": " +sTrace                        ; add trace code AFTER the source code
                EndIf
                ; Debug Len(sTrace)
            
            Else                                                        ; if it is an empty line => Skip
                SkippedLines + 1
                SkipCurrLineF = #True
                sLine = Space(FixedTraceLen)+": "+sLine
            EndIf
        Else                                                            ; SepProcCallsF superseed LineActionFlag (If Not in a skip all directive)
          
            ;If ProcName And (AddFlag & #ADDFLAG_PROCADDR) And (LastActFlag <> #START_SKIP_ALL_DIRECTIVE)
            If DbgStrAfter(pos) And (LastActFlag <> #START_SKIP_ALL_DIRECTIVE) And (LastActFlag <> #SKIP_LOOPS_DIRECTIVE)
            ;         If SepProcCallsF And ProcName <> ""               ; Separate Procedure Calls: add a debug instruction to have an empty line
            ;           sLine = sLine + ": " + sDebug+"("+Chr(34)+TFile+": "+Chr(34)+")"
            ;            
            ;         EndIf
                sLine = AddSpaces(sLine, FixedTraceLen)                 ; add spaces to the source code line
                sLine = sLine + ": " +sTrace                            ; add trace code AFTER the source code
                SkipCurrLineF = #False
            
            Else
                SkippedLines + 1
                SkipCurrLineF = #True
                ; sLine = Space(FixedTraceLen)+": "+sLine
            
            EndIf
          
        EndIf
        
        WritesLine:
        
        ;PB settings may have been saved at the end of the source file
        
        If SingleLineActFlag = #START_PB_SETTINGS 
            If Not EndOfCodeF
                sTrace = sDebug+"('"+TFile+": EOF '): "
                WriteStringN(OutFId, ReplC(sTrace), sf)
                EndOfCodeF = 1
                LastActFlag = #START_PB_SETTINGS
            Else                                                ; simply copy original line
                sLine = sInpLine
                LastActFlag = #START_PB_SETTINGS
            EndIf
                  
        EndIf
        
        If SkipCurrLineF: st = "SKIPPED: ": Else: st = "": EndIf    ; for debug
        ; Debug st + sLine
        If gSkipF = 1
            WriteString(OutFId, sgSkipF + sLine, sf)
          
        ElseIf gSkipF = 0
            WriteString(OutFId, sLine +  sgSkipF, sf)
        Else
            WriteString(OutFId, sLine , sf)
        EndIf
        WriteStringN(OutFId, "", sf)
        
        ;             CloseFile(OutFId): OutFId = 0
        ;             OpenFile(OutFId, OutFN)
        ;             FileSeek(OutFId, Lof(OutFId))
        sgSkipF = ""                                    ; reset global skip string
    
    Wend
    
    CloseFile(InpFId)
    CloseFile(OutFId)
  
    ret = SendMessage_(FindWindow_(#Null, "Debug Output - "+GetFilePart(#PB_Compiler_File)), #WM_CLOSE, 0, 0)
    st = "Source: "+ #TAB$ + InpFN+#CRLF$
    st = st + "Dest: "+ #TAB$ + OutFN+#CRLF$
    st = st + "Lines: "+#TAB$ + "Processed: " + #TAB$+Str(LineNr) + #CRLF$
    st = st + #TAB$+ "Written: " + #TAB$ +#TAB$+ Str(LineNr - SkippedLines) + #CRLF$
    st = st + #TAB$ +"Skipped: "+#TAB$+#TAB$+Str(SkippedLines)
    
    If Not SilentF : MessageRequester("Tracer", st): EndIf
    
    ProcedureReturn 1

EndProcedure ; /////////////////////////////////////////////////////////////////////////////


; show command line before proceeding
If ShowRunParamsF                                       
Define param.s, HelpStr.s, fld, st1.s

    st = "CmdLn: "+ #TAB$ + Mid(CmdLn, FindString(CmdLn, "/", 1)) + #CRLF$ + #CRLF$
    st = st + "InpFN: "+ #TAB$ + InpFN+ #CRLF$ 
    st = st + "OutFN: "+ #TAB$ + OutFN+ #CRLF$ 
    st = st + #CRLF$ 
 
    ; get help string from the same routine that prints it on the console
    ;
    PrintN2("", 1)                                      ; set GetString (vs Console)
    ShowHelp("")                                        ; call std routine
    HelpStr = PrintN2("")                               ; get entire final string
    HelpStr = HelpStr + "/"+#CRLF$                      ; add last separator (for safety)

    ; parse text to get info associate dwith each pramater found in the COmmand Line
    ;
    Repeat     
        fld + 1
        param = "/"+StringField(CmdLn, fld, "/")
        param = StringField(param+" ", 1, " ")
        ; Debug param
        ini = FindString(HelpStr, Left(param, 3), 1)    ; Left(, 2) remove the number (es. /if0 becomes /if)
        If ini And param <> "/"
            fin = FindString(HelpStr, #CRLF$+"/", ini)
            If fin 
                st1 = Mid(HelpStr, Ini, fin - ini+1)
                ; Debug param + #TAB$ + st1
                st = st + param + #TAB$ + ReplaceString(st1, #CRLF$, #CRLF$+#TAB$)
            EndIf   
       EndIf    
    Until param = "/"
           
    st = st + #CRLF$  + "Continue (Yes/No)? "

    ; show result and ask to continue (or not)    
    ret = MessageRequester("MathPad: Command Line", st, #PB_MessageRequester_YesNo)
    
    If ret = #PB_MessageRequester_No
        End #CANCELLED_OPERATION
    EndIf   

EndIf   

sProcsUsed = ""
sProcsDeclared = ""
ClearList(lstProcedures())
ClearList(lstPBFiles())
GetUsedProceduresList(InpFN, 0, 1)                          ; get also procedure names length for line formatting

If SkipUnusedProcsF
  
  GetUsedProceduresList(InpFN, 0, 0)                        ; recall the same procedure with a different flag
  
EndIf

AddElement(lstPBFiles())
lstPBFiles() = OutFN


; setup progressbar form
; 
ret = ListSize(lstPBFiles())
If OpenWindow(0, 0, 0, 320, 160, "Traces Progress", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
    TextGadget       (3,  10, 10, 300,  40, "Processing file: ..."); , #PB_Text_Center)
    ProgressBarGadget(0,  10, 50, 300,  30, 0, ret)
    SetGadgetState   (0, 0)   ;  

    TextGadget       (4,  10, 90, 300,  20, "Overall progress", #PB_Text_Center)
    ProgressBarGadget(1,  10, 110, 300,  30, 0, 100);, #PB_ProgressBar_Smooth)
    SetGadgetState   (1, 0)   
EndIf


; //////////////////////////////////////////////////////////////////////////////////
; /// CALL TO THE MAIN ROUTINE /////////////////////////////////////////////////////
;
ret = TraceFile(InpFN, OutFN, 1)


; Test generated code trying to compile it with minimal parameters
Define hMenu, EditMenu, CtrlX_mnuID, wParam, CompMenu, F5_mnuID, sRes.s =""


If TestCompileF
    ret = Recompile(InpFN, GetPathPart(InpFN), @sRes, #SILENT)
    
    If Not SilentF=0
        If Not ret
          
            MessageRequester("Test Compilation: ERROR ", sRes, 16)
        Else
            MessageRequester("Test Compilation: OK", sRes)
        EndIf
    EndIf
  
EndIf


If ClearDebugViewLogF And TargetId = #Target_DBGSTR ; clear DebugView Log
    hWnd = FindWindow_("dbgviewClass", #Null)
    If Not hWnd
        ; replace this path with the one where DebugView is installed
        ; 
        RunProgram("C:\Program Files\PureBasic_430\plugins\Dbgview.exe", " /f","")
    Else
        ; send Ctrl+X to Debugview to clear the list
        ;
        SendKeys_(hWnd, "{CONTROLDOWN}x{CONTROLUP}")            
    EndIf
    
    Sleep_(20)
  
EndIf

SetForegroundWindow_(FindWindow_("WindowClass_2", #Null))

If LoadFilesInPBEF
    ret = #PB_MessageRequester_Yes
    If Not SilentF
        ret = MessageRequester("Tracer", "Open generated files (Y/N)?")
    EndIf
    LoadFilesInPBE(lstPBFiles(), LoadFilesInPBEF, @RunPBF)
    
EndIf     
  
If RunPBF
  
    ret = MessageRequester("Tracer", "Start PureBasic?"+#CRLF$+#TAB$+"Yes=Run PB & Execute, No=Run PB, Cancel=Exit", #PB_MessageRequester_YesNoCancel)
    
    
    If (ret = #PB_MessageRequester_Yes Or ret = #PB_MessageRequester_No)
        Progr = RunProgram("c:\program files\purebasic_430\purebasic.exe", Chr(34)+OutFN+Chr(34)+" /local", GetPathPart(OutFN), #PB_Program_Open)
        pbPID = ProgramID(Progr)
        WaitForInputIdle_(pbPID, #INFINITE)
        Sleep_(500)
    
    EndIf
    
    If (ret = #PB_MessageRequester_Yes)
        ;hWnd = FindWindow_("WindowClass_2", #Null )
        hWnd = GetForegroundWindow_()
        hWnd = GetActiveWindow_()
        hMenu = GetMenu_(hWnd)                      ; handle of the menu bar
        Compmenu = GetSubMenu_(hMenu, 2)            ; handle of the Compiler Submenu (position 1 starting from 0=File)
        F5_mnuID = GetMenuItemID_(CompMenu, 0)      ; MenuId of the Clear Display (Ctrl+X) menu item (9 his ordinal position starting from 0, including the separators)
        
        SendKeys_(0, "F5", 0)
    EndIf
EndIf


; this section includes the file containing the functions that are used by the
; it is copyed at the beginning of the source file to trace
DataSection
lblPBSource:
    IncludeBinary "TracerAux.pbi"
EndlblPBSource:
EndDataSection
; IDE Options = PureBasic 4.40 Beta 3 (Windows - x86)
; CursorPosition = 733
; FirstLine = 686
; Folding = 4-
; Markers = 332
; EnableThread
; UseIcon = Tools.ico
; Executable = ..\..\plugins\Tracer.exe
; CommandLine = "C:\Program Files\PureBasic_430\Arch\Tracer\Test_EnTimer.pb" /def
; EnableBuildCount = 43
; IncludeVersionInfo
; VersionField0 = 0.0.2.0
; VersionField1 = 0.0.2.0
; VersionField2 = none
; VersionField3 = Tracer
; VersionField4 = 0.0.2.0
; VersionField5 = 0.0.2.0
; VersionField6 = A program to automatically add debug output code to PB souces
; VersionField7 = Tracer
; VersionField8 = Tracer
; VersionField9 = Carlo Somigliana
; VersionField10 = Carlo Somigliana
; VersionField11 = %BUILDCOUNT
; VersionField12 = %BUILDCOUNT
; VersionField13 = somic@libero.it
; VersionField14 = www.semelinanno.com
; Watchlist = GetKeyWord()>kw;GetKeyWord()>sLine