﻿EnableExplicit
Global globalSkipF.b = 0                                    ; this variable controls globally the tracing
;CompilerEndIf

#HRT_GET_Ticks  = 0
#HRT_GET_ns     = 1
#HRT_GET_ms     = 2
#HRT_START      = 4
#HRT_RESTART    = 16
#HRT_INIT       = 8

#EXE = 1
#DLL = 2
#IFNEWER = 4
#SILENT = 8
#EXECUTE = 16

Procedure lDebugF(st.s, AppendF.b=1)
Protected fn.s ="c:\debugf.dbg", f.l, RET, lastErr

    CompilerIf Defined(DebugFN$, #PB_Constant)
        fn = #DebugFN$
    CompilerEndIf
    
    If AppendF
        ; Debug GetLastError_() = 0
        lastErr = GetLastError_()
        f = OpenFile(#PB_Any, fn)
        ; Debug GetLastError_() = 183 if file exist
        SetLastError_(LastErr)
        FileSeek(f, FileSize(fn))
        
    Else
        f = CreateFile(#PB_Any, fn)
        If st = "" 
            st = "Run: "+FormatDate("%dd/%mm/%yyyy - %hh:%ii:%ss", Date())  
        EndIf
    EndIf
        
    If f 
        WriteStringN(f, st)
        FlushFileBuffers(F)
        CloseFile(f)
        ProcedureReturn 1 ; routine processed
        
    Else
        ProcedureReturn 0 ; routine NOT processed

    EndIf
    
EndProcedure

Procedure SendKeys_(hWnd, keys$, NoAttachF=0) 
Protected thread1, thread2, r, s, vk$, s$, vk, NotAKey
Protected shifted, ctrled, alted, kb_capital
; SetWindowLong_(WindowID(0), #GWL_EXSTYLE, GetWindowLong_(hMainWindow, #GWL_EXSTYLE) | #WS_EX_NOACTIVATE)
Static ContF.b

    If hWNd = #Null
        hWnd = GetForegroundWindow_()
    EndIf    
        

    If Not IsWindow_(hWnd)          ; Does the target window actually exist? 
        ProcedureReturn 0: 
    EndIf    ; Nope, so report 0 for failure to type. 
     
    ; Debug hWnd

    ; This block gives the target window the focus before typing. 
    thread1 = GetWindowThreadProcessId_(GetForegroundWindow_(),0) 
    thread2 = GetWindowThreadProcessId_(hWnd, 0) 
    
    ; if (NoAttachF = 0) then can not Attach the two threads but only send data to 
    ; the foreground one (es with File Dialog Boxes)
    ; 
    If (NoAttachF = 0) And thread1 <> thread2 : 
        AttachThreadInput_(thread1, thread2, #True) 
    EndIf 
    
    BringWindowToTop_(hWnd)

    SetForegroundWindow_(hWnd) ; Target window now has the focus for typing. 
    SetFocus_(hWNd)
    WaitForInputIdle_(hWnd, 125)
    Delay(125) ; 1/8 second pause before typing, to prevent fast CPU problems. 
    ; Now the actual typing starts. 
    kb_capital = GetKeyState_(#VK_CAPITAL)

    For r = 1 To Len(keys$) 
        vk$ = Mid(keys$,r,1)
        If kb_capital               ; necessary to avoid case mistmatch
            If vk$ = LCase(vk$)
                vk$ = UCase(vk$)
            Else
                vk$ = LCase(vk$)
            EndIf
        EndIf
         
        If vk$ = "{" ; Special key found. 
            s = FindString(keys$,"}",r+1)-(r+1) ; Get length of special key. 
            s$ = Mid(keys$,r+1,s) ; Get special key name.            
            NotAKey = #False
            Sleep_(1)           ; seems to be necessary only for special caracters
            ; OutDS_(KEYS$+", "+S$+", "+VK$+", shifted: "+Str(shifted))
            Select s$ ; Get virtual key code of special key. 
                Case "BACKSPACE"    : vk = #VK_BACK 
                Case "DELETE"       : vk = #VK_DELETE 
                Case "DOWN"         : vk = #VK_DOWN 
                Case "END"          : vk = #VK_END 
                Case "ENTER"        : vk = #VK_RETURN 
                Case "F1"           : vk = #VK_F1 
                Case "F2"           : vk = #VK_F2 
                Case "F3"           : vk = #VK_F3 
                Case "F4"           : vk = #VK_F4 
                Case "F5"           : vk = #VK_F5 
                Case "F6"           : vk = #VK_F6 
                Case "F7"           : vk = #VK_F7 
                Case "F8"           : vk = #VK_F8 
                Case "F9"           : vk = #VK_F9 
                Case "F10"          : vk = #VK_F10 
                Case "F11"          : vk = #VK_F11 
                Case "F12"          : vk = #VK_F12 
                Case "ESCAPE"       : vk = #VK_ESCAPE 
                Case "HOME"         : vk = #VK_HOME 
                Case "INSERT"       : vk = #VK_INSERT 
                Case "LEFT"         : vk = #VK_LEFT 
                Case "PAGEDOWN"     : vk = #VK_NEXT 
                Case "PAGEUP"       : vk = #VK_PRIOR 
                Case "PRINTSCREEN"  : vk = #VK_SNAPSHOT 
                Case "RETURN"       : vk = #VK_RETURN 
                Case "RIGHT"        : vk = #VK_RIGHT 
                
                Case "SHIFTDOWN"    : shifted = 1 : keybd_event_(#VK_SHIFT, 0, 0, 0) ; Hold SHIFT down. 
                Case "SHIFTUP"      : shifted = 0 : keybd_event_(#VK_SHIFT, 0,#KEYEVENTF_KEYUP, 0) ; Release SHIFT. 
                Case "CTRLDOWN", "CONTROLDOWN": ctrled = 1 : keybd_event_(#VK_CONTROL, 0, 0, 0) ; Hold CONTROL down. 
                Case "CTRLUP", "CONTROLUP"   : ctrled = 0 : keybd_event_(#VK_CONTROL, 0,#KEYEVENTF_KEYUP, 0) ; Release CONTROL. 
                Case "ALTDOWN"      : alted = 1 : keybd_event_(#VK_MENU, 0, 0, 0) ; Hold ALT down. 
                Case "ALTUP"        : alted = 0 : keybd_event_(#VK_MENU, 0,#KEYEVENTF_KEYUP, 0) ; Release ALT. 
                
                Case "TAB"          : vk = #VK_TAB 
                Case "UP"           : vk = #VK_UP 
                
                Default             : NotAKey = #True
            EndSelect 
            ; outds_("shifted: "+Str(shifted))
            If notakey=#False
                If Left(s$,3) <> "ALT" And Left(s$,7) <> "CONTROL" And Left(s$,4) <> "CTRL" And Left(s$,5) <> "SHIFT" 
                    keybd_event_(vk, 0, 0, 0) 
                    keybd_event_(vk, 0,#KEYEVENTF_KEYUP, 0): EndIf  ; Press the special key. 
                   
                r = r+s+1 ; Continue getting the keystrokes that follow the special key. 
        
            Else 
                ; OutDS_(KEYS$+", "+S$+", "+VK$)
                
                vk = VkKeyScanEx_(Asc(vk$),GetKeyboardLayout_(0)) ; Normal key found. 
                keybd_event_(vk, 0, 0, 0) : keybd_event_(vk, 0,#KEYEVENTF_KEYUP, 0) ; Press the normal key. 
            EndIf 
        
        Else; not a special key

            ;LoadKeyboardLayout_("000040c",#KLF_ACTIVATE|#KLF_REORDER)
            vk=VkKeyScanEx_(Asc(vk$),GetKeyboardLayout_(0)) ; Normal key found
            If (vk&$0100)<>0 And shifted = 0 : keybd_event_(#VK_SHIFT,0,0,0) : EndIf ; Due to shifted character.
            If (vk&$0200)<>0 And ctrled = 0 :  keybd_event_(#VK_CONTROL,0,0,0) : EndIf
            If (vk&$0400)<>0 And alted = 0 :   keybd_event_(#VK_MENU,0,0,0) : EndIf
            
            ; OutDS_(KEYS$+", "+S$+", "+VK$+", "+Str(VK))
            keybd_event_(vk,0,0,0)
            keybd_event_(vk,0,#KEYEVENTF_KEYUP,0) ; Press the normal key.
            
            If (vk&$0100)<>0 And shifted = 0 : keybd_event_(#VK_SHIFT,0,#KEYEVENTF_KEYUP,0) : EndIf ; Due to shifted character.
            If (vk&$0200)<>0 And ctrled = 0  : keybd_event_(#VK_CONTROL,0,#KEYEVENTF_KEYUP,0) : EndIf
            If (vk&$0400)<>0 And alted = 0   : keybd_event_(#VK_MENU,0,#KEYEVENTF_KEYUP,0) : EndIf
        EndIf
    Next r
     
    If (NoAttachF = 0) And thread1 <> thread2 : 
        AttachThreadInput_(thread1,thread2,#False) : EndIf ; Finished typing to target window! 




    keybd_event_(#VK_MENU, 0,#KEYEVENTF_KEYUP, 0) ; Release ALT key if user forgot. 
    keybd_event_(#VK_CONTROL, 0,#KEYEVENTF_KEYUP, 0) ; Release CONTROL key if user forgot. 
    keybd_event_(#VK_SHIFT, 0,#KEYEVENTF_KEYUP, 0) ; Release SHIFT key if user forgot. 
    
    ProcedureReturn 1 ; Report successful typing! :) 

; samples
; SendKeys_(0,"This is a test!") ; Type some dummy text. 
; SendKeys_(0,"{CONTROLDOWN}a{CONTROLUP}") ; Select it all. 
; SendKeys_(0,"{DELETE}")      ; Delete it. 

EndProcedure 


Procedure ReCompile(sInpF.s, sOutDir.s, *sRes, Flags = #EXE | #DLL | #IFNEWER | #SILENT | #EXECUTE)
Protected InpF.s, comp.s, params.s, pbPID, Output$, ExitCode2
Protected FileN.s, Ext.s, InpFTime, OutFTime, MsgIcon

    comp.s = Chr(34)+#PB_Compiler_Home+"compilers\pbcompiler.exe"+Chr(34)

    If sOutDir = ""
        sOutDir = #PB_Compiler_FilePath
    EndIf
    
    InpF.s = Chr(34)+sInpF+Chr(34)
    FileN = GetFilePart(InpF)
    Ext = GetExtensionPart(InpF)
    
    params =  InpF 
    If Flags & #EXE
        FileN = ReplaceString(FileN, Ext, "exe")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34)
    ElseIf Flags & #DLL
        FileN = ReplaceString(FileN, Ext, "dll")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34) +" /DLL"
    EndIf
    
    InpFTime = GetFileDate(sInpF, #PB_Date_Modified)
    OutFTime = GetFileDate(sOutDir+FileN, #PB_Date_Modified)
    
    If InpFTime > OutFTime Or (Not (Flags & #IFNEWER))
    
    ; +" > c:\pbc.txt"
        pbPID = RunProgram(comp, params, sOutDir, #PB_Program_Open | #PB_Program_Read); | #PB_Program_Write )

        If pbPID
            Output$ = "Program: "+comp+ Chr(13)
            Output$ = Output$ + "Params: "+#TAB$+StringField(params+"/", 1, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 2, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 3, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 4, "/") + Chr(13)

            While ProgramRunning(pbPID)
                Output$ = Output$ + ReadProgramString(pbPID) + Chr(13)
            Wend
            Output$ + #CRLF$; Chr(13) + Chr(13)
            ExitCode2 = ProgramExitCode(pbPID)
            
            If ExitCode2
                Output$ + "Exitcode: " + Str(ExitCode2) + " - COMPILER ERROR"
            Else
                Output$ + "Exitcode: " + Str(ExitCode2) + " - RESULT OK"
            EndIf
            
            If *sRes > 0
                PokeS(*sRes, Output$)
            EndIf
; VbCritical 16 Visualizza l'icona di messaggio critico.  
; VbQuestion 32 Visualizza l'icona di richiesta di avviso. 
; VbExclamation 48 Visualizza l'icona di messaggio di avviso. 
; VbInformation 64 Visualizza l'icona di messaggio di informazione. 
            
            
            
            If ExitCode2 <> 0
                If Not (Flags & #SILENT) : MessageRequester("Recompile /// WARNING: COMPILER ERROR ///", Output$, 16): EndIf
            Else
                If Not(Flags & #SILENT) : MessageRequester("Recompile : /// COMPILE OK ///", Output$, 0): EndIf
            EndIf
            
            If ExitCode2 = 0 
                If  Flags & #EXECUTE
                    pbPID = RunProgram(Chr(34)+sOutDir+FileN+Chr(34), "", sOutDir)
                
                Else
                    pbPID = 1
                EndIf
                
            Else
                pbPID = 0
                
            EndIf
        
            ProcedureReturn pbPID
        Else
        
            MessageRequester("ERROR", "ERROR")
            ProcedureReturn 0
        
        EndIf
    Else
    
        ProcedureReturn 1

    EndIf    

EndProcedure


Global Dim dMult.d(2), gdFreq.d

Procedure.q HRTimerWait(ns.q)
Protected qTicks.q, qEndTicks.q, dEndTicks.d
    
    QueryPerformanceCounter_(@qTicks)                        ; first thing get ticks
    dEndTicks = qTicks + ns /1000000000 * gdFreq
    
    qEndTicks = dEndTicks
    
;     Debug "Expr = " +Str(qEndTicks) + " - " +Str(qTicks)
;     Debug ""
    
    ;!LD DWORD[WaitTicks]
    Repeat 
        QueryPerformanceCounter_(@qTicks)
        ; Debug qTicks - qEndTicks
        
    Until (qTicks - qEndTicks) > 0
        
EndProcedure

Procedure.q HRTimer(HRTAction.l=0)
Static dFreq.d, dStartTicks.d, qFreq.q, qStartTicks.q
Protected qTicks.q, dTicks.d, qRet.q, T1.LARGE_INTEGER, dRet.d
;Shared Mult.q()

    QueryPerformanceCounter_(@qTicks)                        ; first thing get ticks
    
    dTicks = qTicks
        
    If Not dFreq 
        QueryPerformanceFrequency_(@qFreq)
        dFreq = qFreq
        gdFreq = dFreq
        
        If Not qFreq                                        ; in Hz
    
            ProcedureReturn 0
            
        Else
           
            dMult(#HRT_GET_Ticks) = 1.0
            dMult(#HRT_GET_ns) = 1000000000.0 / dFreq ; convert ns to ms = / 10^6
            dMult(#HRT_GET_ms) = 1000.0 / dFreq

            dStartTicks = dTicks
            
        EndIf
    EndIf
    
    If HRTAction = #HRT_START
        
        dStartTicks = dTicks
        ProcedureReturn dStartTicks
        
    ElseIf HRTAction & #HRT_RESTART                             ; automatically restart the counter
        
        QueryPerformanceCounter_(@qStartTicks)                       
        HRTAction - #HRT_RESTART
        dRet = (dTicks - dStartTicks) * dMult(HRTAction)

        dStartTicks = qStartTicks
       
    Else
        dRet = (dTicks - dStartTicks) * dMult(HRTAction)
        
    EndIf

    ProcedureReturn dRet;qRet
    
EndProcedure

Procedure.b IsNumeric(String$)
Protected st.s
    
    If Val(String$) <> 0
        ProcedureReturn 1
        
    Else
    
        st = Trim(Trim(String$, "0"), " ")
        If st = "." Or st = ","
            ProcedureReturn 1
            
        Else
            ProcedureReturn 0
        EndIf     
    
    EndIf

EndProcedure

Procedure.s GetWinText(hWnd)
Protected Text.s, lret

    Text=Space(256) 
    lret = GetWindowText_(hWnd, Text, 256) 
    
    ProcedureReturn Left(Text, lret)

EndProcedure

Procedure.s GetClassName(hWnd)
Protected Text.s, lret

    Text=Space(256) 
    lret = GetClassName_(hWnd, Text, 256) 
    
    ProcedureReturn Left(Text, lret)

EndProcedure

Procedure.s GetWinData(hWnd)
Protected st.s

    st = GetWinText(hWnd)+"/"+GetClassName(hWnd)
    
    ProcedureReturn st
    
EndProcedure

Procedure OutDS_(String$)

    If globalSkipF: ProcedureReturn 0 : EndIf    

    OutputDebugString_(String$)

EndProcedure

Procedure.s sTID()
    ProcedureReturn Str(GetCurrentThreadId_())
EndProcedure

Procedure.s sTh()
    ProcedureReturn Str(GetCurrentThread_())
EndProcedure

Procedure SendToWnd(String$, TxtEncode = 0)
; ////////////////////////////////////////////////////////////////////////////////////////////
; /// manage Target = ProcessWnd
Protected DefDir.s, CurPath.s, hModule, ret, ClassN.s, WndTxt.s
Static InitProcessWnd.b, pNum, hWnd, cWnd, i
    
    If globalSkipF: ProcedureReturn 0 : EndIf    
    
    If Not InitProcessWnd                                   ; init procedure if not done yet
    
        If LCase(GetExtensionPart(#ProcessWnd)) = "exe"      ; if it is a program to run 
            ; Look for the process running in memory
            hModule = GetModuleHandle_(#ProcessWnd)         ; must be mapped in the same address space
            If hModule
                ; GetGUIThreadInfo, GetWindowThreadProcessId , GetCurrentThreadId, EnumProcesses 
                ; GetClassName_(
            Else
            
;                 DefDir = GetPathPart(InpFN)
;                 If DefDir = ""
;                     CurPath = GetPathPart(PeekS(GetCommandLine_()))             
;                 EndIf
                pNum = RunProgram(#ProcessWnd, "", DefDir, #PB_Program_Open | #PB_Program_Write) 
                If Not pNum
                    hWnd = WindowID(pNum)
                    ProcedureReturn hWNd
                
                EndIf
            EndIf               
         Else                                               ; if it is a window to find (es. ClassName, ,)
            ClassN = StringField(#ProcessWnd, 1, ",")
            WndTxt = StringField(#ProcessWnd, 2, ",")

            If ClassN = "" And WndTxt = ""
                hWnd = 0
                
            ElseIf ClassN <> "" And WndTxt = ""
                hWnd = FindWindow_(ClassN, #Null)
            
            ElseIf ClassN <> "" And WndTxt <> ""
                hWnd = FindWindow_(ClassN, WndTxt)

            ElseIf ClassN = "" And WndTxt <> ""
                hWnd = FindWindow_(#Null, WndTxt)
                
            EndIf
         
        EndIf
                 
        InitProcessWnd = 1
         
    EndIf
    
    If InitProcessWnd And IsWindow_(hWNd) 
        Sendkeys_(hWnd, String$)
        
    EndIf

    ProcedureReturn ret


EndProcedure

Procedure SendToClpB(String$)
Protected st.s

    If globalSkipF: ProcedureReturn 0 : EndIf    

    st = GetClipboardText()
    st = st + String$
    ClearClipboard()
    SetClipboardText(st)

EndProcedure

; Procedure DebugC(st.s)
;     PrintN(st)
; EndProcedure

CompilerIf 0; #PB_Compiler_Debugger
    Define k, qT1.q, qT2.q, dDt1.d, dDt2.d
    Define dT1.d, dT2.d

    OpenConsole()

    HRTimer(#HRT_START)                   ; init timer 
    Sleep_(1000)
    DebugC( Str(HRTimer(#HRT_GET_ns)) +" ns")
    DebugC( Str(HRTimer(#HRT_GET_ms)) +" ms")
    
    qT1 = HRTimer(#HRT_GET_ns)
    qT2 = HRTimer(#HRT_GET_ns)
    dDt1 = (qT2 - qT1)
    DebugC("LT for 2 HRTimer(#HRT_GET_ns) calls")
    DebugC (#TAB$ + StrD(dDt1,2) +" ns")

    QueryPerformanceCounter_(@qT1)
    QueryPerformanceCounter_(@qT2)
    dDt2 = (qT2 - qT1)/gdFreq*1000000000
    DebugC("LT for 2 QueryPerformanceCounter calls")
    debugC(#TAB$ + StrD(qT2 - qT1,2) +" ticks = "+StrD(dDt2,2)+" ns")
    
    DebugC( "Overhead of the HRTimer(#HRT_GET_ns) vs direct API Call")
    DebugC( #TAB$ + StrD(dDt1 - dDt2,2) +" ns")
    
    qT1 = HRTimer(#HRT_GET_Ticks)
    qT2 = HRTimer(#HRT_GET_Ticks)
    dDt1 = (qT2 - qT1)/gdFreq*1000000000
    DebugC( "Overhead of the HRTimer(#HRT_GET_Ticks) vs direct API call")
    DebugC( #TAB$ + StrD(dDt1 - dDt2,2) +" ns")

    DebugC( ""   ) 
    For k = 1 To 1000

        HRTimer(#HRT_GET_ns)
    
    Next k
    
    DebugC( Str(HRTimer(#HRT_GET_ms + #HRT_RESTART)) +" ms for 1000 HRTimer(#HRT_GET_ns) calls")
    
    Sleep_(100): Debugc("SLEEP 100 ms")
    DebugC( Str(HRTimer(#HRT_GET_ms )) +" ms")
    
    DebugC("press enter to run the Precision Test...")

        
    ; Input() ; //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    Define LTns.q, LTms.q, i, qElapsedns.q, qStartns.q
    
    DebugC("")
    DebugC("HiRes Timer Precision Test")
    DebugC("#    ns" + #TAB$ + "   ms "+#TAB$+"Std Timer    "+#TAB$ + "Err%" + #TAB$ + "HiRes Timer "+#TAB$ +" Err% ")
    For i = 3 To 9
        LTns = 1 * Pow(10, i)
        LTms = LTns/1000000
        Print(Str(i) +"  10^"+Str(i) + #TAB$+"   "+Str(LTms))
        
        If LTms >= 1
            HRTimer(#HRT_START): 
            Sleep_(LTms)
            qElapsedns = HRTimer(#HRT_GET_ns):      
            ; Print(Str(StdElapsedns) +" ns" + #TAB$ + StrD(Elapsedns/LTns(i)*100, 2) + #TAB$ + Str(Elapsedns) + #TAB$ )
            Print(#TAB$ + Str(qElapsedns) +" ns" + #TAB$  + StrD(100-qElapsedns /LTns*100, 2) + #TAB$ )
        Else
            Print(#TAB$+"Skipped" + #TAB$ + #TAB$ + " n/a " + #TAB$ )
        EndIf
        
        ; qStartns = ElapsedMilliseconds()
        ; Debug (ElapsedMilliseconds() - qStartns)
        HRTimer(#HRT_START)
        HRTimerWait(LTns)
        qElapsedns = HRTimer(#HRT_GET_ns):      
        Print(Str(qElapsedns) +" ns  " + #TAB$ + StrD(100-qElapsedns/LTns*100, 2))

        DebugC("")
;         DebugC(Str(Elapsedns) +" ns " + #TAB$ + #TAB$ +"Err% = "+StrD(Elapsedns/LTns(i)*100, 2))
;         DebugC("HiRes StopWatch Stopped after "+Str(Elapsedns) +" ns = "+Str(Elapsedns/1000000)+" ms, Err% = "+StrD(Elapsedns/LTns(i)*100, 2))
    Next i

    DebugC ("Press enter to END")
    Input()
    CloseConsole()

CompilerEndIf

; IDE Options = PureBasic 4.40 Beta 3 (Windows - x86)
; CursorPosition = 443
; FirstLine = 195
; Folding = k--
; EnableXP