﻿EnableExplicit
; /// constants to manage PB keywords listed in LineActionFlag

; reserved up to                     
#DONT_SKIP_THIS_LINE                 = 0
#SKIP_THIS_LINE                      = 1
#START_BLOCK_SKIPPING_FROM_THIS_LINE = 2
#START_BLOCK_SKIPPING_FROM_NEXT_LINE = 13 ; TO BE TESTED
#STOP_BLOCK_SKIPPING_FROM_THIS_LINE  = 3
#STOP_BLOCK_SKIPPING_FROM_NEXT_LINE  = 4
#SKIP_2_LINES                        = 5 
#START_SKIP_ALL_DIRECTIVE            = 6 
#STOP_SKIP_ALL_DIRECTIVE             = 7 
#START_PB_SETTINGS                   = 8  
#SKIP_LPP_DIRECTIVE                  = 9  

#SKIP_LOOPS_DIRECTIVE                = 10 
#TRACE_LOOPS_DIRECTIVE               = 11  

#TRACE_THIS_LINE                     = 12   ; override every other flag

#START_LOOP_SKIPPING_FROM_THIS_LINE  = #START_BLOCK_SKIPPING_FROM_THIS_LINE
#STOP_LOOP_SKIPPING_FROM_NEXT_LINE   = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE

; reserved up to                     
#MAX_LINE_ACTION_FLAG                = 10000 ; 2^16

; 
#ADD_CMD_HRTIMER_START               = #MAX_LINE_ACTION_FLAG +1
#ADD_CMD_HRTIMER_STOP                = #MAX_LINE_ACTION_FLAG +2

#MaxKwsID = 50
Global LoopsK1, LoopsK2, DirectIdx
Global Dim skw.s(#MaxKwsID)
Global Dim LineActionFlag.l(#MaxKwsID): 
Global Dim ValidCharsAfter.s(#MaxKwsID) ; Global Dim ValidCharsBefore.s(#MaxKwsID): 
Global Dim DbgStrAfter.b(#MaxKwsID)     ; std is before (0), exception is after (1)
Global sValidCharsBefore.s = " :"+#TAB$, InclFNId, ProcRetId, ProcIdx, EndProcIdx


;Global sValidCharsBeforeProcCall.s = " :(=/+*-@|&"+#TAB$
Declare.l IncL(*lng)
Define MaxKW, k, LOOPSKIPDIR.l = 1

; Special PureBasic KeyWords
k=0                               : LineActionFlag(k) = #DONT_SKIP_THIS_LINE
skw(IncL(@k)) = "IncludeFile"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
InclFNId = k ; 1
skw(IncL(@k)) = "XIncludeFile"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
skw(IncL(@k)) = "IncludePath"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
skw(IncL(@k)) = "EnableExplicit"  : LineActionFlag(k) = #SKIP_THIS_LINE                         : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "EndStructure"    : LineActionFlag(k) = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Structure"       : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE    : ValidCharsAfter(k) = " "+#TAB$
LoopsK1 = k+1   ; 6
skw(IncL(@k)) = "For"             : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Next"            : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "While"           : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Wend"            : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Repeat"          : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Until"           : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :"+#TAB$
LoopsK2 = k ; 12
skw(IncL(@k)) = "With"            : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Global"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Shared"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Define"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Protected"       : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "ProcedureReturn" : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " (;"+#TAB$
ProcRetId = k   ; 18
skw(IncL(@k)) = "DeclareCDLL"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "DeclareDLL"      : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Declare"         : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "ProcedureCDLL"   : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "ProcedureDLL"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
;skw(IncL(@k)) = "EndProcedure"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "EndProcedure"    : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " :;"+#TAB$
EndProcIdx = k  ; 24
skw(IncL(@k)) = "ProcedureCDLL"   : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " ."+#TAB$   : DbgStrAfter(k)=1
skw(IncL(@k)) = "ProcedureDLL"    : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " ."+#TAB$   : DbgStrAfter(k)=1
skw(IncL(@k)) = "ProcedureC"      : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " ."+#TAB$   : DbgStrAfter(k)=1
skw(IncL(@k)) = "Procedure"       : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " ."+#TAB$   : DbgStrAfter(k)=1
ProcIdx = k
; skw(IncL(@k)) = "EndSelect"       : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
; skw(IncL(@k)) = "Select"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
; skw(IncL(@k)) = "Case"            : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " "+#TAB$: DbgStrAfter(k)=1
; skw(IncL(@k)) = "Select"          : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE: ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Select"          : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_NEXT_LINE: ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Case"            : LineActionFlag(k) =  #STOP_BLOCK_SKIPPING_FROM_THIS_LINE: ValidCharsAfter(k) = " "+#TAB$: DbgStrAfter(k)=1

skw(IncL(@k)) = "EndMacro"        : LineActionFlag(k) =  #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :"+#TAB$
skw(IncL(@k)) = "Macro"           : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$

DirectIdx = 31
; Tracer program directives ; dal nr 31 al 41
skw(IncL(@k)) = "$DisableDebugOutput": LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE    ; without ; to avoid problems with commented lines
skw(IncL(@k)) = "$EnableDebugOutput" : LineActionFlag(k) =  #STOP_SKIP_ALL_DIRECTIVE    ; 
skw(IncL(@k)) = "IDE Options"     : LineActionFlag(k) = #START_PB_SETTINGS              ; set init of settings at the end of the pb file
skw(IncL(@k)) = "$DisTracer"      : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE
skw(IncL(@k)) = "$EnTracer"       : LineActionFlag(k) =  #STOP_BLOCK_SKIPPING_FROM_THIS_LINE       ; 
skw(IncL(@k)) = "$DisDBG"         : LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE       ; 
skw(IncL(@k)) = "$EnDBG"          : LineActionFlag(k) =  #STOP_SKIP_ALL_DIRECTIVE       ;
skw(IncL(@k)) = "$Trace"          : LineActionFlag(k) = #TRACE_THIS_LINE               ;
skw(IncL(@k)) = "$DisLoops"       : LineActionFlag(k) = #SKIP_LOOPS_DIRECTIVE     ;     (Default)
skw(IncL(@k)) = "$EnLoops"        : LineActionFlag(k) = #TRACE_LOOPS_DIRECTIVE     ;

; Tracer program code commands
skw(IncL(@k)) = "$HRTStart"       : LineActionFlag(k) = #ADD_CMD_HRTIMER_START          ; 
skw(IncL(@k)) = "$HRTStop"        : LineActionFlag(k) = #ADD_CMD_HRTIMER_STOP           ; 

; Little PureBasic Preprocessor Directive
skw(IncL(@k)) = "$LPP"            : LineActionFlag(k) = #SKIP_LPP_DIRECTIVE; | #SKIP_THIS_LINE                 
skw(IncL(@k)) = " _"              : LineActionFlag(k) = #SKIP_2_LINES                   ; LPP line breaker

MaxKW = k


Procedure IsAnUsedProcedure(ProcNm.s, sUsedProcs.s)
Protected ret    
    ret = FindString(LCase(sUsedProcs), LCase(ProcNm), 1)
    
    If ret
        ProcedureReturn ret
    Else
        ProcedureReturn 0
    EndIf


EndProcedure

Procedure.s CutAnyComments(String$, TrimF.b)
Protected sRes.s, st.s, pos

    If TrimF: st = Trim(String$): Else: st = String$: EndIf                                  ; remove comment (for shortening the line)
    pos = FindString(st, ";", 1)
    
    If pos
        sRes = RTrim(Mid(st, 1, pos-1))
    Else
        sRes = st
    EndIf

    ProcedureReturn sRes
    
EndProcedure


Procedure SkipUnusedProcs(sLine.s, ProcName.s, sProcsUsed.s, PrevBlockSkipF)
Protected st.s, NewBlockSkipF

    NewBlockSkipF = PrevBlockSkipF
    
    If ProcName <> ""
        
        If SkipUnusedProcsF
            
            ; Debug ProcName
            ; CallDebugger
            
            If Not IsAnUsedProcedure(ProcName, sProcsUsed)

                NewBlockSkipF = 1; #START_BLOCK_SKIPPING_FROM_THIS_LINE               
                
            EndIf   
        EndIf

    Else
    
        st = CutAnyComments(sLine, 1)
        If FindString(LCase(st), "endprocedure", 1)
        
            If SkipUnusedProcsF And (PrevBlockSkipF > 0) 
                
                ; Debug sLine
                ; CallDebugger
                
                NewBlockSkipF = 0
                
            EndIf   
        EndIf   
    EndIf

; 
    ProcedureReturn NewBlockSkipF
    
EndProcedure

Procedure.s sTID()
    ProcedureReturn Str(GetCurrentThreadId_())
EndProcedure

Procedure.s AddSpaces(String$, MaxLenght)
Protected sRes.s, spc

    String$ = ReplaceString(String$, #TAB$, sTabLen)
    
    If MaxLenght = 0
        sRes = String$

    Else

        spc = MaxLenght - Len(String$) 
        If spc < 0                                          ; truncate
            sRes = String$

        Else                                                ; remove last 3 closing line chars ')" - add spaces and re-add 3 closing line chars
            sRes = String$+Space(spc)

        EndIf

    EndIf
    
ProcedureReturn sRes

EndProcedure

Procedure.s PrintN2(String$, GetStr.b=-1)
Static lGetStr.b, sRet.s

    If GetStr <> -1 
        sRet = ""
        lGetStr = GetStr: EndIf
        
    
    If lGetStr = 1
        sRet = sRet + String$ + #CRLF$
        ProcedureReturn sRet
        
    Else
        PrintN(String$): EndIf    
    
EndProcedure

Procedure ShowHelp(param.s)
        
        PrintN2("Command line: Tracer <filename> [parameters]")
        PrintN2("")
        PrintN2("/h or /? = show this help screen (/hd shows DIRECTIVES only)")
        PrintN2("")
        If param <> "/hd"
            PrintN2("<SourceFN>  = set the input filename (first parameter mandatory)")
            PrintN2("/of<DestFN> = set the Output Filename")
            PrintN2("                 if empty, the same name with prefix _$_ will be used")
            PrintN2("                 if a directory, it is used for output")
            PrintN2("/tg<Target> = set the destination of the debug output string. Values are: ")
            PrintN2("    DebugView - use DebugView by Sysinternals as destination")
            PrintN2("    StdFile   - write output to disk file c:\debugf.dbg")
            PrintN2("    number    - process id (decimal or hex) of a running program to")
            PrintN2("                send the strings via PeekMessage - no error check")
            PrintN2("    ProcessWnd - Class name and/or Window Title of the destination")
            PrintN2("                 requires /pw <ClassName, WindowText> (es. /pw Notepad,,)")
            PrintN2("                          /cn <Control Name or Id>    (es. /cn 1 or /cn Edit)")
            PrintN2("                application to SendMessage the Debug strings To")
            PrintN2("                (es. Notepad, 0,")
            PrintN2("/fl<Filter> = set the Filter string to identify output (Default 'FileName.Ext')")
            PrintN2("/def     = use DEFault settings, when not specified (overidden)")
                  ; +--------++--------++--------++--------++--------++--------++--------++--------+
            PrintN2("/af#     = set the info to send to debug output     (es. /af1 - Default = 3)")
            PrintN2("             bitflag of 1, 2 and 4  =>  0= Line Numbers (always)")
            PrintN2("                                        1 = Procedure Names")
            PrintN2("                                        2 = Procedure Address")
            PrintN2("                                        4 = Line Address (TO BE IMPLEMENTED)")
            PrintN2("                                        8 = Thread Nr    (TO BE IMPLEMENTED)")
            PrintN2("")
            PrintN2("/ln#     = space in char for the Line Number        (es. /ln8 - Default = 5)")
            PrintN2("/pn#     = space in char for the Procedure Name     (es. /pn25 - Default = 20)")
            PrintN2("/pa#     = space in char for the Procedure Address  (es. /pa10 - Default = 8)")
            PrintN2("/xc#     = limit the debug output string to the given length in Characters")
            PrintN2("           for dest. file readability; 0 = no limit (es. /xc100 - Default = 125)")
            PrintN2("/ac(0-1) = Add the Code in the debug output string  (es. /ac0 - Default = 1)")
            PrintN2("/he(0-1) = write numbers in HEx format              (Default = 1)")
            PrintN2("/el(0-1) = add an Empty Line at the the beginning of the debug session")
            PrintN2("             (Default = 1) ")
            PrintN2("/sp(0-1) = add an empty line at the entry of every procedure (for readeability)")
            PrintN2("             (Default = 1)")
;             PrintN("/md(0-1) = if the lDebugF procedure is Missing (and needed), add a reference ")
;             PrintN("             to a file that must be in the source directory (Default = 0)")
;             PrintN("/hr(0-1) = if the HRTimer is missing (and needed), add a reference to a file ")
;             PrintN("             to a file that must be in the source directory     (Default = 1)")
            PrintN2("/cd(0-1) = try to Clear DebugView log list                      (Default = 1)")
            PrintN2("/rn(0-1) = RuN the purebasic editor after finishing             (Default = 0)")
            PrintN2("/tc(0-1) = Test generated Code with pbcompiler                  (Default = 0)")
            PrintN2("/on(0-1) = execute Only if source file is Newer than dest file  (Default = 0)")
            PrintN2("/sl(0-1) = deactivate/activate prompting for messages (SiLent)  (Default = 0)")
            PrintN2("/if(0-1) = ricursively trace also files in the IncludeFile/Path (Default = 0)")
            PrintN2("/ri(0-1) = add a Run Info comment in the first line             (Default = 1)")
            PrintN2("/sd(0-1) = All files generated are Saved in the dest. folder    (Default = 1)")
            PrintN2("/sv(0-1) = enable the Variable view feature (TO BE IMPLEMENTED) (Default = 0)")
            PrintN2("/su(0-1) = Skip Unused Procedures           (TO BE TESTED)      (Default = 0)")
            PrintN2("/sc(0-1) = Skip Constants                   (TO BE IMPLEMENTED) (Default = 0)")
            PrintN2("/lf(0-2) = Load generated Files in PB IDE - 0=No, 1=Main Source, 2=All (Def=1)")
            PrintN2("/cc(0-1) = Count Procedure calls and add in the output string   (Default = 0)")
            PrintN2("")
            PrintN2("tip: adding some empty lines at the begin of your source code file allow Tracer")
            PrintN2("       to use them for IncludeFile and TimeStamp line preserving corrispondence")
            PrintN2("       of line number between source and destination file")
            PrintN2("")
        EndIf

                   ;|--------++--------++--------++--------++--------++--------++--------++--------!
        PrintN2("DIRECTIVES:")
        PrintN2("Source Code DIRECTIVES: added to the source code to take special actions")
        PrintN2("                        includes ';' to have it ignored by PB")
        ; Tracer program directives
        PrintN2(";$DisableDebugOutput= disable adding the debug output code until")
        PrintN2("                      ;$EnableDebugOutput (or ;$EnDBG or ;$EnTfracer) is found")
        PrintN2(";$DisDBG, $DisTracer= same as above (short format) ")
        PrintN2(";$EnableDebugOutput = enable adding the debug output code (Default)")
        PrintN2(";$EnDBG, $EnTracer  = same as above (short format) ")
        PrintN2(";$DisLoops          = Skip Loops (For/Next, While/Wend, Repeat/Until) (Default)")
        PrintN2("                      to avoid eccessive and useless use of ouput string")
        PrintN2(";$EnLoops           = Enable loops (For/Next, While/Wend, Repeat/Until) ")
        PrintN2("                      Enable Tracer in the Loops (when iterations are not many")
        PrintN2(";$Trace             = force tracing of current line (override everything)")
        PrintN2(";IDE Options        = indicate the beginning of the PB IDE options section")
        PrintN2("                      to be skipped")

        ; Tracer program code commands
        PrintN2("")
        PrintN2("Source code COMMANDS: instruct Tracer to add commands in the dest. file")
        PrintN2("Code PROFILING commands"); without ;
        PrintN2(";$HRTStart           = add a High Resolution Timer Start command"); without ;
        PrintN2(";$HRTStop            = add a High Resolution Timer Stop command and show result")
        
        PrintN2("")
        PrintN2("Other DIRECTIVES:")
        ; Little PureBasic Preprocessor Directive
        PrintN2(";$LPP                = Little PureBasic Preprocessor (LPP) Directive")
        PrintN2("' _' characters      = Little PureBasic Preprocessor Line Breaker"); LPP line breaker
    
EndProcedure

Procedure.s StringFieldKey(String$, Key$, sDefault$="", Sep.s="/")
Protected ini, fin, CmdLn.s, sRes.s

    If Sep = "": Sep = Left(Key$, 1): EndIf
    ; CmdLn = LCase(String$ + Sep)
    ini = FindString(LCase(String$)+Sep, Key$, 1)
    
    If ini 
        ini = ini +Len(Key$)
        CmdLn = LTrim(Mid(String$, ini))+Sep
        fin = FindString(CmdLn, Sep, 1)
        
        If fin
            sRes = Trim(Left(CmdLn, fin-1))
            ProcedureReturn sRes
            
        EndIf
    
    Else
    
        ProcedureReturn sDefault$
    
    EndIf
    
EndProcedure

Procedure.s GetCmdLineParam(sCmdLn.s, sFlag.s, sDef.s="")
Protected ini, fin, CmdLn.s, sRes.s

    cmdln = LCase(sCmdLn + " ")
    ini = FindString(CmdLn, sFlag, 1)
    
    If ini 
        ini = ini +Len(sFlag)
        CmdLn = LTrim(Mid(sCmdLn, ini))+" "
        fin = FindString(CmdLn, " ", 1)
        
        If fin
            sRes = Trim(Left(CmdLn, fin))
            ProcedureReturn sRes
        EndIf
    
    EndIf
    
    ProcedureReturn sDef
    
EndProcedure

Procedure.s ReplC(sProcAddr.s)

    ProcedureReturn ReplaceString(sProcAddr, "'", ""+Chr(34)+"")
    
EndProcedure

Procedure.l IncL(*lng)
Protected lng.l

    lng = PeekL(*lng)
    lng = lng + 1
    PokeL(*lng, lng)
    
    ProcedureReturn lng
    
EndProcedure

Procedure HasCharBeforeAndAfter(String$, skw.s, Index)
Protected car.s, pos, Idx

    If Index = -1: Idx = 1: Else : Idx = Index: EndIf
    
   If ValidCharsAfter(Idx) = ""                               ; if not defined it is a directive
        ProcedureReturn 0
        
    EndIf
    car = ""

    pos = FindString(LCase(String$), LCase(skw), 1)        ; get keyword position
    If pos > 1
        car = LCase(Mid(String$, pos-1, 1))                       ; check if it is Whole Word
    EndIf
    
    ; Index = -1 means check procedure call (can have many more characters before), so no check; criticality is low
    If Index >=0 And car <> "" And Not FindString(sValidCharsBefore, car, 1)  ; a character before the KeyWord if found (es QueryPer'for'manceFrequency)
        ProcedureReturn 1
        
    EndIf
    
    car = Mid(String$, pos+Len(skw), 1)

    If car <> "" And Not FindString(ValidCharsAfter(Idx), car, 1)
        ProcedureReturn 1

    EndIf

    ProcedureReturn 0                                       ; no chars before or after: it is a pure keyword

EndProcedure

#RET_LINEWORD   = 0
#RET_KEYWORD    = 1
Procedure.s GetKeyWord(sLine.s, kw.s, kwIdx, FlagF.b=#RET_LINEWORD)
Protected pos, pos2, pos3, ProcName.s, st.s, cnt
Protected i, OpenQuotesF.b, ini, fin, car.s, lkw.s, lsLine.s, ln

    sLine = LTrim(sLine)                                    ; remove comment (for safety)
    pos = FindString(sLine, ";", 1)
    cnt = CountString(Mid(sLine, 1, pos), Chr(34))          ; if quotes are odd then ; is inside a string
    If (cnt % 2) = 1
        pos = 0
    EndIf   

    pos2 = FindString(sLine, ";$", 1) 
    cnt = CountString(Mid(sLine, 1, pos2), Chr(34))          ; if quotes are odd then ; is inside a string
    If (cnt % 2) = 1
        pos2 = 0
    EndIf   
    
    pos3 = FindString(sLine, "; IDE Options", 1)
    cnt = CountString(Mid(sLine, 1, pos3), Chr(34))          ; if quotes are odd then words are inside a string
    If (cnt % 2) = 1
        pos3 = 0
    EndIf   
    
    If pos And Not pos2 And Not pos3                        ; remove comment
        sLine = Mid(sLine, 1, pos)
    EndIf

    ; Debug kw
    ; for speed reason; do detailed check only if keyword is found
    pos = FindString(LCase(sLine), LCase(kw), 1)            ; look for keyword
    If Not pos 
        ProcedureReturn ""
    EndIf   

    cnt = CountString(Mid(sLine, 1, pos), Chr(34))          ; if quotes are odd then keyword inside a string
    If (cnt % 2) = 1
        ProcedureReturn ""
    EndIf   
    
    ; continue checks 
    If HasCharBeforeAndAfter(sLine, kw, kwIdx)
        ProcedureReturn ""
        
    EndIf
    
    If FlagF = #RET_LINEWORD                                ; if 0 (default) returns the word from the line    

        ini = FindString(LCase(sLine), " ", 1)
        If Not ini
            ProcedureReturn ""
        EndIf
        fin = FindString(LCase(sLine), "(", ini)
        
        If fin
            ProcName = Trim(Mid(sLine, ini, fin - ini))
        EndIf
        
        ProcedureReturn ProcName
        
    Else
        
        ProcedureReturn kw                          ; if 1 (default) returns the word taken from the array of kws
    
    EndIf

    
EndProcedure

Procedure IsAProcDeclaration(sLine.s, *ProcName)
Protected k, pos, st.s, car.s
    
     For k = ProcRetId +1 To ProcIdx
        
        If skw(k) = ""
            Break
        EndIf
        ; Debug skw(k)
        st = GetKeyWord(sLine, skw(k), k, 0)                ; here checks also character before and after
                                                            ; to be sure the whole word matches.
        If (skw(k) <> "") And  (st <> "")
            PokeS(*ProcName, st)
            ProcedureReturn k

        EndIf
        
    Next k
    
    ProcedureReturn 0
    

EndProcedure

Procedure CheckSkipKeyWord(sLine.s)
Protected k, pos, st.s, car.s
    
    For k = 1 To ArraySize(LineActionFlag())
        If skw(k) = ""
            Break
        EndIf
        ; Debug skw(k)
        st = GetKeyWord(sLine, skw(k), k, 1)                ; here checks also character before and after
                                                            ; to be sure the whole word matches.
        If skw(k) <> "" And  st <> ""
        
            ProcedureReturn k

        EndIf
        
    Next k
    
    ProcedureReturn 0
    

EndProcedure

Procedure IsADirective(sLine.s)
Protected k, pos, st.s, car.s
    
    For k = DirectIdx To ArraySize(LineActionFlag())
        If skw(k) = ""
            Break
        EndIf
        ; Debug skw(k)
        st = GetKeyWord(sLine, skw(k), k, 1)                ; here checks also character before and after
                                                            ; to be sure the whole word matches.
        If skw(k) <> "" And  st <> ""
        
            ProcedureReturn k

        EndIf
        
    Next k
    
    ProcedureReturn 0
    

EndProcedure

#EXE = 1
#DLL = 2
#IFNEWER = 4
#SILENT = 8
#EXECUTE = 16


Procedure Recompile(sInpF.s, sOutDir.s, *sRes, Flags = #EXE | #DLL | #IFNEWER | #SILENT | #EXECUTE)
Protected InpF.s, comp.s, params.s, pbPID, Output$, ExitCode2
Protected FileN.s, Ext.s, InpFTime, OutFTime, MsgIcon

    comp.s = Chr(34)+#PB_Compiler_Home+"compilers\pbcompiler.exe"+Chr(34)

    If sOutDir = ""
        sOutDir = #PB_Compiler_FilePath
    EndIf
    
    InpF.s = Chr(34)+sInpF+Chr(34)
    FileN = GetFilePart(InpF)
    Ext = GetExtensionPart(InpF)
    
    params =  InpF 
    If Flags & #EXE
        FileN = ReplaceString(FileN, Ext, "exe")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34)
    ElseIf Flags & #DLL
        FileN = ReplaceString(FileN, Ext, "dll")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34) +" /DLL"
    EndIf
    
    InpFTime = GetFileDate(sInpF, #PB_Date_Modified)
    OutFTime = GetFileDate(sOutDir+FileN, #PB_Date_Modified)
    
    If InpFTime > OutFTime Or (Not (Flags & #IFNEWER))
    
    ; +" > c:\pbc.txt"
        pbPID = RunProgram(comp, params, sOutDir, #PB_Program_Open | #PB_Program_Read); | #PB_Program_Write )

        If pbPID
            Output$ = "Program: "+comp+ Chr(13)
            Output$ = Output$ + "Params: "+#TAB$+StringField(params+"/", 1, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 2, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 3, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 4, "/") + Chr(13)

            While ProgramRunning(pbPID)
                Output$ = Output$ + ReadProgramString(pbPID) + Chr(13)
            Wend
            Output$ + #CRLF$; Chr(13) + Chr(13)
            ExitCode2 = ProgramExitCode(pbPID)
            
            If ExitCode2
                Output$ + "Exitcode: " + Str(ExitCode2) + " - COMPILER ERROR"
            Else
                Output$ + "Exitcode: " + Str(ExitCode2) + " - RESULT OK"
            EndIf
            
            If *sRes > 0
                PokeS(*sRes, Output$)
            EndIf
; VbCritical 16 Visualizza l'icona di messaggio critico.  
; VbQuestion 32 Visualizza l'icona di richiesta di avviso. 
; VbExclamation 48 Visualizza l'icona di messaggio di avviso. 
; VbInformation 64 Visualizza l'icona di messaggio di informazione. 
            
            
            
            If ExitCode2 <> 0
                If Not (Flags & #SILENT) : MessageRequester("Recompile /// WARNING: COMPILER ERROR ///", Output$, 16): EndIf
            Else
                If Not(Flags & #SILENT) : MessageRequester("Recompile : /// COMPILE OK ///", Output$, 0): EndIf
            EndIf
            
            If ExitCode2 = 0 
                If  Flags & #EXECUTE
                    pbPID = RunProgram(Chr(34)+sOutDir+FileN+Chr(34), "", sOutDir)
                
                Else
                    pbPID = 1
                EndIf
                
            Else
                pbPID = 0
                
            EndIf
        
            ProcedureReturn pbPID
        Else
        
            MessageRequester("ERROR", "ERROR")
            ProcedureReturn 0
        
        EndIf
    Else
    
        ProcedureReturn 1

    EndIf    

EndProcedure

Procedure.l DoEvents(hWnd.l = 0, CallingProc.s="", CallingLine=0)
Protected msg.MSG, cnt.l, lret

; BOOL PeekMessage(          
;     LPMSG lpMsg,
;     HWND hWnd,
;     UINT wMsgFilterMin,
;     UINT wMsgFilterMax,
;     UINT wRemoveMsg
; );
; HWND
;[in] Handle to the window whose messages are to be retrieved. The window must belong to the current thread. 
;If hWnd is NULL, PeekMessage retrieves messages For any window that belongs To the current thread, And any 
;messages on the current thread's message queue whose hwnd value is NULL (see the MSG structure). 
;Therefore if hWnd is NULL, both window messages and thread messages are processed.

;If hWnd is -1, PeekMessage retrieves only messages on the current thread's message queue whose hwnd value is NULL, 
;that is, thread messages as posted by PostMessage (when the hWnd parameter is NULL) or PostThreadMessage.
    If CallingProc <> "" Or CallingLine <> 0
        ; debugf(CallingProc+"("+Str(callingline)+"): DoEvents: cnt="+Str(cnt))
    EndIf
    
    While PeekMessage_(@msg, hWnd, 0, 0, #PM_REMOVE)
        cnt = cnt + 1 
        lret = TranslateMessage_(@msg) 
        lret = DispatchMessage_(@msg) 
        lret = Delay(5) ; SleepEx_(5, #True)
        Wend

 
    ProcedureReturn cnt
               
EndProcedure


Procedure SendKeys_(hWnd, keys$, NoAttachF=0) 
Protected thread1, thread2, r, s, vk$, s$, vk, NotAKey
Protected shifted, ctrled, alted, kb_capital
; SetWindowLong_(WindowID(0), #GWL_EXSTYLE, GetWindowLong_(hMainWindow, #GWL_EXSTYLE) | #WS_EX_NOACTIVATE)
Static ContF.b

    If hWNd = #Null
        hWnd = GetForegroundWindow_()
    EndIf    
        

    If Not IsWindow_(hWnd)          ; Does the target window actually exist? 
        ProcedureReturn 0: 
    EndIf    ; Nope, so report 0 for failure to type. 
     
    ; Debug hWnd

    ; This block gives the target window the focus before typing. 
    thread1 = GetWindowThreadProcessId_(GetForegroundWindow_(),0) 
    thread2 = GetWindowThreadProcessId_(hWnd, 0) 
    
    ; if (NoAttachF = 0) then can not Attach the two threads but only send data to 
    ; the foreground one (es with File Dialog Boxes)
    ; 
    If (NoAttachF = 0) And thread1 <> thread2 : 
        AttachThreadInput_(thread1, thread2, #True) 
    EndIf 
    
    BringWindowToTop_(hWnd)

    SetForegroundWindow_(hWnd) ; Target window now has the focus for typing. 
    SetFocus_(hWNd)
    WaitForInputIdle_(hWnd, 125)
    Delay(125) ; 1/8 second pause before typing, to prevent fast CPU problems. 
    ; Now the actual typing starts. 
    kb_capital = GetKeyState_(#VK_CAPITAL)

    For r = 1 To Len(keys$) 
        vk$ = Mid(keys$,r,1)
        If kb_capital               ; necessary to avoid case mistmatch
            If vk$ = LCase(vk$)
                vk$ = UCase(vk$)
            Else
                vk$ = LCase(vk$)
            EndIf
        EndIf
         
        If vk$ = "{" ; Special key found. 
            s = FindString(keys$,"}",r+1)-(r+1) ; Get length of special key. 
            s$ = Mid(keys$,r+1,s) ; Get special key name.            
            NotAKey = #False
            Sleep_(1)           ; seems to be necessary only for special caracters
            ; OutDS_(KEYS$+", "+S$+", "+VK$+", shifted: "+Str(shifted))
            Select s$ ; Get virtual key code of special key. 
                Case "BACKSPACE"    : vk = #VK_BACK 
                Case "DELETE"       : vk = #VK_DELETE 
                Case "DOWN"         : vk = #VK_DOWN 
                Case "END"          : vk = #VK_END 
                Case "ENTER"        : vk = #VK_RETURN 
                Case "F1"           : vk = #VK_F1 
                Case "F2"           : vk = #VK_F2 
                Case "F3"           : vk = #VK_F3 
                Case "F4"           : vk = #VK_F4 
                Case "F5"           : vk = #VK_F5 
                Case "F6"           : vk = #VK_F6 
                Case "F7"           : vk = #VK_F7 
                Case "F8"           : vk = #VK_F8 
                Case "F9"           : vk = #VK_F9 
                Case "F10"          : vk = #VK_F10 
                Case "F11"          : vk = #VK_F11 
                Case "F12"          : vk = #VK_F12 
                Case "ESCAPE"       : vk = #VK_ESCAPE 
                Case "HOME"         : vk = #VK_HOME 
                Case "INSERT"       : vk = #VK_INSERT 
                Case "LEFT"         : vk = #VK_LEFT 
                Case "PAGEDOWN"     : vk = #VK_NEXT 
                Case "PAGEUP"       : vk = #VK_PRIOR 
                Case "PRINTSCREEN"  : vk = #VK_SNAPSHOT 
                Case "RETURN"       : vk = #VK_RETURN 
                Case "RIGHT"        : vk = #VK_RIGHT 
                
                Case "SHIFTDOWN"    : shifted = 1 : keybd_event_(#VK_SHIFT, 0, 0, 0) ; Hold SHIFT down. 
                Case "SHIFTUP"      : shifted = 0 : keybd_event_(#VK_SHIFT, 0,#KEYEVENTF_KEYUP, 0) ; Release SHIFT. 
                Case "CTRLDOWN", "CONTROLDOWN": ctrled = 1 : keybd_event_(#VK_CONTROL, 0, 0, 0) ; Hold CONTROL down. 
                Case "CTRLUP", "CONTROLUP"   : ctrled = 0 : keybd_event_(#VK_CONTROL, 0,#KEYEVENTF_KEYUP, 0) ; Release CONTROL. 
                Case "ALTDOWN"      : alted = 1 : keybd_event_(#VK_MENU, 0, 0, 0) ; Hold ALT down. 
                Case "ALTUP"        : alted = 0 : keybd_event_(#VK_MENU, 0,#KEYEVENTF_KEYUP, 0) ; Release ALT. 
                
                Case "TAB"          : vk = #VK_TAB 
                Case "UP"           : vk = #VK_UP 
                
                Default             : NotAKey = #True
            EndSelect 
            ; outds_("shifted: "+Str(shifted))
            If notakey=#False
                If Left(s$,3) <> "ALT" And Left(s$,7) <> "CONTROL" And Left(s$,4) <> "CTRL" And Left(s$,5) <> "SHIFT" 
                    keybd_event_(vk, 0, 0, 0) 
                    keybd_event_(vk, 0,#KEYEVENTF_KEYUP, 0): EndIf  ; Press the special key. 
                   
                r = r+s+1 ; Continue getting the keystrokes that follow the special key. 
        
            Else 
                ; OutDS_(KEYS$+", "+S$+", "+VK$)
                
                vk = VkKeyScanEx_(Asc(vk$),GetKeyboardLayout_(0)) ; Normal key found. 
                keybd_event_(vk, 0, 0, 0) : keybd_event_(vk, 0,#KEYEVENTF_KEYUP, 0) ; Press the normal key. 
            EndIf 
        
        Else; not a special key

            ;LoadKeyboardLayout_("000040c",#KLF_ACTIVATE|#KLF_REORDER)
            vk=VkKeyScanEx_(Asc(vk$),GetKeyboardLayout_(0)) ; Normal key found
            If (vk&$0100)<>0 And shifted = 0 : keybd_event_(#VK_SHIFT,0,0,0) : EndIf ; Due to shifted character.
            If (vk&$0200)<>0 And ctrled = 0 :  keybd_event_(#VK_CONTROL,0,0,0) : EndIf
            If (vk&$0400)<>0 And alted = 0 :   keybd_event_(#VK_MENU,0,0,0) : EndIf
            
            ; OutDS_(KEYS$+", "+S$+", "+VK$+", "+Str(VK))
            keybd_event_(vk,0,0,0)
            keybd_event_(vk,0,#KEYEVENTF_KEYUP,0) ; Press the normal key.
            
            If (vk&$0100)<>0 And shifted = 0 : keybd_event_(#VK_SHIFT,0,#KEYEVENTF_KEYUP,0) : EndIf ; Due to shifted character.
            If (vk&$0200)<>0 And ctrled = 0  : keybd_event_(#VK_CONTROL,0,#KEYEVENTF_KEYUP,0) : EndIf
            If (vk&$0400)<>0 And alted = 0   : keybd_event_(#VK_MENU,0,#KEYEVENTF_KEYUP,0) : EndIf
        EndIf
    Next r
     
    If (NoAttachF = 0) And thread1 <> thread2 : 
        AttachThreadInput_(thread1,thread2,#False) : EndIf ; Finished typing to target window! 




    keybd_event_(#VK_MENU, 0,#KEYEVENTF_KEYUP, 0) ; Release ALT key if user forgot. 
    keybd_event_(#VK_CONTROL, 0,#KEYEVENTF_KEYUP, 0) ; Release CONTROL key if user forgot. 
    keybd_event_(#VK_SHIFT, 0,#KEYEVENTF_KEYUP, 0) ; Release SHIFT key if user forgot. 
    
    ProcedureReturn 1 ; Report successful typing! :) 

; samples
; SendKeys_(0,"This is a test!") ; Type some dummy text. 
; SendKeys_(0,"{CONTROLDOWN}a{CONTROLUP}") ; Select it all. 
; SendKeys_(0,"{DELETE}")      ; Delete it. 

EndProcedure 

Procedure.s GetWinTitle(Handle) 
Protected name.s
    Name = Space(255) 
    GetWindowText_(Handle, @Name, Len(Name)) 
    ProcedureReturn Left(Name, Len(Name)) 
EndProcedure 

Procedure LoadFilesInPBE(List lstPBFiles.s(), lLoadFilesInPBE, *RunPBF)
Protected hSysTab32, mnuCnt, ini, mnuText.s, mnuMain, i, FoundF.b
Protected pbWnd, sciWnd, fName.s, TabIdx, ret, btnWnd, cnt

    pbWnd = FindWindow_("WindowClass_2", 0)
    If Not pbWnd 
        ProcedureReturn 0
    EndIf   
;         sciWnd = FindWindowEx_(pbWnd, 0, "Scintilla", 0)
;         If sciWnd
;         
;         EndIf   


    ; GetDlgItemText_ #WM_GETTEXT etc doesn't work for external processes/threads
    ; will develop code for code injection to execute a function
    AddElement(lstPBFiles())
    lstPBFiles() = GetPathPart(gMainInpFN)+"_$_TracerAux.pbi"
    ini = 0
    If 1
        
        hSysTab32 = GetDlgItem_(pbWnd, 1)
        cnt  = SendMessage_(hSysTab32, #TCM_GETITEMCOUNT, 0, 0)
        ForEach lstPBFiles()
            Debug lstPBFiles()
            FoundF = #False
            For i = 0 To cnt ; one more to return to the first one
    
                fName = GetWinTitle(pbWnd)
                fName = Mid(fName, FindString(fName, ":", 1)-1)
                Debug GetFilePart(LCase(fName))
                If LCase(fName) = LCase(lstPBFiles())
                    Debug "Found => Close & Open"
                    SendKeys_(pbWnd, "{CTRLDOWN}w{CTRLUP}")
                    Delay(100)
                    DoEvents(0)

;                     SendKeys_(pbWnd, "{CTRLDOWN}o{CTRLUP}")
;                     Delay(100)
;                     SendKeys_(0, fName+"{RETURN}")
;                     ; ini = i
                    Break   
                    
                EndIf   
                sendkeys_(pbWnd, "{CONTROLDOWN}{TAB}{CONTROLUP}")  
                Delay(100)
                DoEvents(0)
            Next i
;            If Not FoundF
                SendKeys_(pbWnd, "{CTRLDOWN}o{CTRLUP}")
                Delay(100)
                DoEvents(0)
                SendKeys_(0, lstPBFiles()+"{RETURN}")
                Delay(100)
                DoEvents(0)
;            EndIf   
            ; ini = 0

            If lLoadFilesInPBE = 1 : Break: EndIf    
    
        Next

        
    ElseIf 0
        ; here open the file to activate it (even if already in the IDE), close it and re open it
        ;
        fName = lstPBFiles() ; GetPathPart(lstPBFiles())+"_$_"+GetFilePart(lstPBFiles())
        SendKeys_(pbWnd, "{CTRLDOWN}o{CTRLUP}")
        Delay(100)
        
;             ClearClipboard()
;             SetClipboardText(fName)
        SendKeys_(0, fName+"{RETURN}")
        Delay(100)
        SendKeys_(pbWnd, "{CTRLDOWN}w{CTRLUP}")
        Delay(100)

        SendKeys_(pbWnd, "{CTRLDOWN}o{CTRLUP}")
        Delay(100)
        SendKeys_(0, fName+"{RETURN}")
                               
    Else
    
        RunProgram(Chr(34)+lstPBFiles()+Chr(34), "", GetPathPart(lstPBFiles())) ; load the file; if already loaded, 
                                                                                ; activate it (without reload)
        Delay(200)                                                              ; wait file load
        Doevents()
        SendKeys_(pbWnd, "{CTRLDOWN}w{CTRLUP}")
        
        Debug lstPBFiles()
        Delay(100)                                                              ; wait file close
         
        RunProgram(Chr(34)+lstPBFiles()+Chr(34), "", GetPathPart(lstPBFiles())) ; load again the file
    
    EndIf           

 
    If PeekB(*RunPBF)
        SendKeys_(pbWnd, "{F5}", 0)
        PokeB(*RunPBF, 0)               ; to stop the next block after this routine
    EndIf   

EndProcedure
; IDE Options = PureBasic 4.40 Beta 3 (Windows - x86)
; CursorPosition = 171
; FirstLine = 149
; Folding = ---+
; EnableXP
; UseMainFile = Tracer.pb